Linux ubuntu 6.8.0-90-generic #91-Ubuntu SMP PREEMPT_DYNAMIC Tue Nov 18 14:14:30 UTC 2025 x86_64
nginx/1.24.0
: 67.217.245.49 | : 216.73.216.50
Cant Read [ /etc/named.conf ]
8.3.6
www-data
Bypass.pw
Terminal
AUTO ROOT
Adminer
Backdoor Destroyer
Linux Exploit
Lock Shell
Lock File
Create User
CREATE RDP
PHP Mailer
BACKCONNECT
UNLOCK SHELL
HASH IDENTIFIER
Backdoor Scanner
Backdoor Create
Alfa Webshell
CPANEL RESET
CREATE WP USER
README
+ Create Folder
+ Create File
/
usr /
bin /
[ HOME SHELL ]
Name
Size
Permission
Action
NF
963
B
-rwxr-xr-x
VGAuthService
130.54
KB
-rwxr-xr-x
[
54.44
KB
-rwxr-xr-x
aa-enabled
18.3
KB
-rwxr-xr-x
aa-exec
18.3
KB
-rwxr-xr-x
aa-features-abi
18.3
KB
-rwxr-xr-x
ab
58.43
KB
-rwxr-xr-x
acpidbg
1.58
KB
-rwxr-xr-x
add-apt-repository
16.04
KB
-rwxr-xr-x
addpart
14.38
KB
-rwxr-xr-x
apport-bug
2.27
KB
-rwxr-xr-x
apport-cli
13.31
KB
-rwxr-xr-x
apport-collect
2.27
KB
-rwxr-xr-x
apport-unpack
3.7
KB
-rwxr-xr-x
appstreamcli
138.23
KB
-rwxr-xr-x
apropos
47.28
KB
-rwxr-xr-x
apt
18.38
KB
-rwxr-xr-x
apt-add-repository
16.04
KB
-rwxr-xr-x
apt-cache
86.47
KB
-rwxr-xr-x
apt-cdrom
26.47
KB
-rwxr-xr-x
apt-config
30.39
KB
-rwxr-xr-x
apt-extracttemplates
22.47
KB
-rwxr-xr-x
apt-ftparchive
222.48
KB
-rwxr-xr-x
apt-get
50.47
KB
-rwxr-xr-x
apt-key
27.99
KB
-rwxr-xr-x
apt-mark
54.47
KB
-rwxr-xr-x
apt-sortpkgs
50.4
KB
-rwxr-xr-x
arch
34.51
KB
-rwxr-xr-x
aria_chk
5.52
MB
-rwxr-xr-x
aria_dump_log
5.31
MB
-rwxr-xr-x
aria_ftdump
5.32
MB
-rwxr-xr-x
aria_pack
5.35
MB
-rwxr-xr-x
aria_read_log
5.48
MB
-rwxr-xr-x
aulast
18.3
KB
-rwxr-xr-x
aulastlog
14.3
KB
-rwxr-xr-x
ausyscall
14.3
KB
-rwxr-xr-x
automat-visualize3
984
B
-rwxr-xr-x
auvirt
38.38
KB
-rwxr-xr-x
awk
722.5
KB
-rwxr-xr-x
b2sum
54.51
KB
-rwxr-xr-x
base32
38.51
KB
-rwxr-xr-x
base64
38.51
KB
-rwxr-xr-x
basename
34.51
KB
-rwxr-xr-x
basenc
46.51
KB
-rwxr-xr-x
bash
1.38
MB
-rwxr-xr-x
bashbug
6.82
KB
-rwxr-xr-x
bc
90.82
KB
-rwxr-xr-x
boltctl
122.84
KB
-rwxr-xr-x
bpftrace
2.15
MB
-rwxr-xr-x
bpftrace-aotrt
985.37
KB
-rwxr-xr-x
btrfs
1001.25
KB
-rwxr-xr-x
btrfs-convert
576.3
KB
-rwxr-xr-x
btrfs-find-root
520.3
KB
-rwxr-xr-x
btrfs-image
552.3
KB
-rwxr-xr-x
btrfs-map-logical
520.3
KB
-rwxr-xr-x
btrfs-select-super
516.3
KB
-rwxr-xr-x
btrfsck
1001.25
KB
-rwxr-xr-x
btrfstune
544.3
KB
-rwxr-xr-x
busctl
94.59
KB
-rwxr-xr-x
busybox
2.03
MB
-rwxr-xr-x
byobu
8.5
KB
-rwxr-xr-x
byobu-config
996
B
-rwxr-xr-x
byobu-ctrl-a
4.66
KB
-rwxr-xr-x
byobu-disable
1.26
KB
-rwxr-xr-x
byobu-disable-prompt
1.31
KB
-rwxr-xr-x
byobu-enable
1.15
KB
-rwxr-xr-x
byobu-enable-prompt
1.42
KB
-rwxr-xr-x
byobu-export
1.39
KB
-rwxr-xr-x
byobu-janitor
7.04
KB
-rwxr-xr-x
byobu-keybindings
1.47
KB
-rwxr-xr-x
byobu-launch
3.25
KB
-rwxr-xr-x
byobu-launcher
1.87
KB
-rwxr-xr-x
byobu-launcher-install
2.47
KB
-rwxr-xr-x
byobu-launcher-uninstall
1.52
KB
-rwxr-xr-x
byobu-layout
3.27
KB
-rwxr-xr-x
byobu-prompt
1.13
KB
-rwxr-xr-x
byobu-quiet
1.38
KB
-rwxr-xr-x
byobu-reconnect-sockets
3.22
KB
-rwxr-xr-x
byobu-screen
8.5
KB
-rwxr-xr-x
byobu-select-backend
1.42
KB
-rwxr-xr-x
byobu-select-profile
5.06
KB
-rwxr-xr-x
byobu-select-session
1012
B
-rwxr-xr-x
byobu-shell
1.66
KB
-rwxr-xr-x
byobu-silent
1.28
KB
-rwxr-xr-x
byobu-status
5.87
KB
-rwxr-xr-x
byobu-status-detail
1.18
KB
-rwxr-xr-x
byobu-tmux
8.5
KB
-rwxr-xr-x
byobu-ugraph
4.56
KB
-rwxr-xr-x
byobu-ulevel
11.71
KB
-rwxr-xr-x
c_rehash
6.68
KB
-rwxr-xr-x
captoinfo
90.41
KB
-rwxr-xr-x
cat
38.46
KB
-rwxr-xr-x
catman
30.77
KB
-rwxr-xr-x
certbot
958
B
-rwxr-xr-x
cftp3
224
B
-rwxr-xr-x
cgi-fcgi
18.15
KB
-rwxr-xr-x
chage
70.49
KB
-rwxr-sr-x
chardet
221
B
-rwxr-xr-x
chardetect
221
B
-rwxr-xr-x
chattr
14.31
KB
-rwxr-xr-x
chcon
58.51
KB
-rwxr-xr-x
checkgid
14.3
KB
-rwxr-xr-x
chfn
71.09
KB
-rwsr-xr-x
chgrp
58.51
KB
-rwxr-xr-x
chmod
54.51
KB
-rwxr-xr-x
choom
22.38
KB
-rwxr-xr-x
chown
58.51
KB
-rwxr-xr-x
chrt
30.38
KB
-rwxr-xr-x
chsh
43.71
KB
-rwsr-xr-x
chvt
14.37
KB
-rwxr-xr-x
cifsiostat
26.45
KB
-rwxr-xr-x
ckbcomp
147.14
KB
-rwxr-xr-x
ckeygen3
227
B
-rwxr-xr-x
cksum
102.52
KB
-rwxr-xr-x
clambc
6.68
MB
-rwxr-xr-x
clamscan
162.38
KB
-rwxr-xr-x
clamsubmit
126.38
KB
-rwxr-xr-x
clear
14.31
KB
-rwxr-xr-x
clear_console
14.23
KB
-rwxr-xr-x
cloud-id
966
B
-rwxr-xr-x
cloud-init
970
B
-rwxr-xr-x
cloud-init-per
2.06
KB
-rwxr-xr-x
cmp
42.39
KB
-rwxr-xr-x
codepage
14.3
KB
-rwxr-xr-x
col
22.38
KB
-rwxr-xr-x
col1
963
B
-rwxr-xr-x
col2
963
B
-rwxr-xr-x
col3
963
B
-rwxr-xr-x
col4
963
B
-rwxr-xr-x
col5
963
B
-rwxr-xr-x
col6
963
B
-rwxr-xr-x
col7
963
B
-rwxr-xr-x
col8
963
B
-rwxr-xr-x
col9
963
B
-rwxr-xr-x
colcrt
14.38
KB
-rwxr-xr-x
colrm
14.38
KB
-rwxr-xr-x
column
38.38
KB
-rwxr-xr-x
comm
38.52
KB
-rwxr-xr-x
conch3
225
B
-rwxr-xr-x
corelist
15.01
KB
-rwxr-xr-x
cp
138.52
KB
-rwxr-xr-x
cpan
8.16
KB
-rwxr-xr-x
cpan5.38-x86_64-linux-gnu
8.18
KB
-rwxr-xr-x
cpio
137.67
KB
-rwxr-xr-x
cpupower
1.58
KB
-rwxr-xr-x
crontab
38.73
KB
-rwxr-sr-x
csplit
50.51
KB
-rwxr-xr-x
ctail
960
B
-rwxr-xr-x
ctstat
22.66
KB
-rwxr-xr-x
curl
290.32
KB
-rwxr-xr-x
cut
38.51
KB
-rwxr-xr-x
cvtsudoers
321.1
KB
-rwxr-xr-x
dash
126.74
KB
-rwxr-xr-x
date
106.51
KB
-rwxr-xr-x
dbilogstrip
1.35
KB
-rwxr-xr-x
dbiprof
6.06
KB
-rwxr-xr-x
dbiproxy
5.27
KB
-rwxr-xr-x
dbpmda
94.8
KB
-rwxr-xr-x
dbus-cleanup-sockets
14.29
KB
-rwxr-xr-x
dbus-daemon
230.64
KB
-rwxr-xr-x
dbus-monitor
26.3
KB
-rwxr-xr-x
dbus-run-session
14.3
KB
-rwxr-xr-x
dbus-send
30.29
KB
-rwxr-xr-x
dbus-update-activation-environ...
14.29
KB
-rwxr-xr-x
dbus-uuidgen
14.29
KB
-rwxr-xr-x
dbxtool
30.3
KB
-rwxr-xr-x
dd
70.54
KB
-rwxr-xr-x
deallocvt
14.37
KB
-rwxr-xr-x
deb-systemd-helper
23.79
KB
-rwxr-xr-x
deb-systemd-invoke
6.97
KB
-rwxr-xr-x
debconf
2.8
KB
-rwxr-xr-x
debconf-apt-progress
11.57
KB
-rwxr-xr-x
debconf-communicate
623
B
-rwxr-xr-x
debconf-copydb
1.68
KB
-rwxr-xr-x
debconf-escape
668
B
-rwxr-xr-x
debconf-set-selections
3.14
KB
-rwxr-xr-x
debconf-show
1.78
KB
-rwxr-xr-x
debian-distro-info
30.95
KB
-rwxr-xr-x
delpart
14.38
KB
-rwxr-xr-x
delv
45.32
KB
-rwxr-xr-x
df
87.08
KB
-rwxr-xr-x
dh_bash-completion
4.42
KB
-rwxr-xr-x
dh_installxmlcatalogs
9.22
KB
-rwxr-xr-x
dh_perl_dbi
1.17
KB
-rwxr-xr-x
diff
134.55
KB
-rwxr-xr-x
diff3
58.52
KB
-rwxr-xr-x
dig
150.83
KB
-rwxr-xr-x
dir
138.98
KB
-rwxr-xr-x
dircolors
46.52
KB
-rwxr-xr-x
dirmngr
473.77
KB
-rwxr-xr-x
dirmngr-client
54.92
KB
-rwxr-xr-x
dirname
34.38
KB
-rwxr-xr-x
distro-info
26.89
KB
-rwxr-xr-x
dmesg
68.64
KB
-rwxr-xr-x
dnsdomainname
22.23
KB
-rwxr-xr-x
do-release-upgrade
10.42
KB
-rwxr-xr-x
domainname
22.23
KB
-rwxr-xr-x
dpkg
310.72
KB
-rwxr-xr-x
dpkg-deb
142.58
KB
-rwxr-xr-x
dpkg-divert
118.57
KB
-rwxr-xr-x
dpkg-maintscript-helper
20.71
KB
-rwxr-xr-x
dpkg-query
134.56
KB
-rwxr-xr-x
dpkg-realpath
4.09
KB
-rwxr-xr-x
dpkg-split
98.53
KB
-rwxr-xr-x
dpkg-statoverride
50.38
KB
-rwxr-xr-x
dpkg-trigger
42.53
KB
-rwxr-xr-x
dstat
74.98
KB
-rwxr-xr-x
du
98.51
KB
-rwxr-xr-x
dumpkeys
162.85
KB
-rwxr-xr-x
eatmydata
2.74
KB
-rwxr-xr-x
ec2metadata
8.38
KB
-rwxr-xr-x
echo
34.38
KB
-rwxr-xr-x
ed
58.55
KB
-rwxr-xr-x
editor
272.5
KB
-rwxr-xr-x
efibootdump
22.3
KB
-rwxr-xr-x
efibootmgr
47.69
KB
-rwxr-xr-x
egrep
41
B
-rwxr-xr-x
eject
42.23
KB
-rwxr-xr-x
enc2xs
40.96
KB
-rwxr-xr-x
encguess
3
KB
-rwxr-xr-x
env
46.95
KB
-rwxr-xr-x
envsubst
34.38
KB
-rwxr-xr-x
eqn
188.45
KB
-rwxr-xr-x
ex
3.94
MB
-rwxr-xr-x
expand
34.53
KB
-rwxr-xr-x
expiry
26.52
KB
-rwxr-sr-x
expr
42.41
KB
-rwxr-xr-x
factor
62.51
KB
-rwxr-xr-x
faillog
22.63
KB
-rwxr-xr-x
fallocate
26.38
KB
-rwxr-xr-x
false
26.3
KB
-rwxr-xr-x
fcgistarter
14.3
KB
-rwxr-xr-x
fgconsole
14.37
KB
-rwxr-xr-x
fgrep
41
B
-rwxr-xr-x
filan
50.48
KB
-rwxr-xr-x
file
30.6
KB
-rwxr-xr-x
finalrd
2.06
KB
-rwxr-xr-x
find
199.48
KB
-rwxr-xr-x
findmnt
67.66
KB
-rwxr-xr-x
flock
22.48
KB
-rwxr-xr-x
fmt
38.51
KB
-rwxr-xr-x
fold
34.51
KB
-rwxr-xr-x
free
26.38
KB
-rwxr-xr-x
freshclam
162.24
KB
-rwxr-xr-x
ftp
182.9
KB
-rwxr-xr-x
funzip
26.3
KB
-rwxr-xr-x
fuser
39.34
KB
-rwxr-xr-x
fusermount
38.38
KB
-rwsr-xr-x
fusermount3
38.38
KB
-rwsr-xr-x
fwupdmgr
118.3
KB
-rwxr-xr-x
fwupdtool
110.3
KB
-rwxr-xr-x
galera_new_cluster
917
B
-rwxr-xr-x
galera_recovery
3.29
KB
-rwxr-xr-x
gapplication
22.38
KB
-rwxr-xr-x
gawk
722.5
KB
-rwxr-xr-x
gawkbug
6.74
KB
-rwxr-xr-x
gdbus
50.38
KB
-rwxr-xr-x
gencat
26.44
KB
-rwxr-xr-x
genpmda
29.17
KB
-rwxr-xr-x
geqn
188.45
KB
-rwxr-xr-x
getconf
26.36
KB
-rwxr-xr-x
getent
38.72
KB
-rwxr-xr-x
getkeycodes
14.37
KB
-rwxr-xr-x
getopt
22.38
KB
-rwxr-xr-x
gettext
34.38
KB
-rwxr-xr-x
gettext.sh
5.07
KB
-rwxr-xr-x
ginstall-info
47.24
KB
-rwxr-xr-x
gio
102.4
KB
-rwxr-xr-x
gio-querymodules
18.3
KB
-rwxr-xr-x
git
3.88
MB
-rwxr-xr-x
git-receive-pack
3.88
MB
-rwxr-xr-x
git-shell
624.81
KB
-rwxr-xr-x
git-upload-archive
3.88
MB
-rwxr-xr-x
git-upload-pack
3.88
MB
-rwxr-xr-x
glib-compile-schemas
54.3
KB
-rwxr-xr-x
gpasswd
74.46
KB
-rwsr-xr-x
gpg
1.09
MB
-rwxr-xr-x
gpg-agent
357.52
KB
-rwxr-xr-x
gpg-connect-agent
87.3
KB
-rwxr-xr-x
gpg-wks-client
139.37
KB
-rwxr-xr-x
gpgconf
115.36
KB
-rwxr-xr-x
gpgparsemail
34.38
KB
-rwxr-xr-x
gpgsm
501.37
KB
-rwxr-xr-x
gpgsplit
26.62
KB
-rwxr-xr-x
gpgtar
67.83
KB
-rwxr-xr-x
gpgv
303.14
KB
-rwxr-xr-x
gpic
196.06
KB
-rwxr-xr-x
grep
182.45
KB
-rwxr-xr-x
gresource
22.3
KB
-rwxr-xr-x
groff
94.51
KB
-rwxr-xr-x
grog
18.75
KB
-rwxr-xr-x
grops
162.55
KB
-rwxr-xr-x
grotty
118.51
KB
-rwxr-xr-x
groups
34.51
KB
-rwxr-xr-x
growpart
29.19
KB
-rwxr-xr-x
grub-editenv
393.16
KB
-rwxr-xr-x
grub-file
741.88
KB
-rwxr-xr-x
grub-fstest
863.32
KB
-rwxr-xr-x
grub-glue-efi
102.88
KB
-rwxr-xr-x
grub-kbdcomp
1.64
KB
-rwxr-xr-x
grub-menulst2cfg
83.2
KB
-rwxr-xr-x
grub-mkfont
131.45
KB
-rwxr-xr-x
grub-mkimage
377.26
KB
-rwxr-xr-x
grub-mklayout
103.23
KB
-rwxr-xr-x
grub-mknetdir
429.77
KB
-rwxr-xr-x
grub-mkpasswd-pbkdf2
111.32
KB
-rwxr-xr-x
grub-mkrelpath
259.79
KB
-rwxr-xr-x
grub-mkrescue
1019.84
KB
-rwxr-xr-x
grub-mkstandalone
510.16
KB
-rwxr-xr-x
grub-mount
682.21
KB
-rwxr-xr-x
grub-ntldr-img
38.39
KB
-rwxr-xr-x
grub-render-label
750.23
KB
-rwxr-xr-x
grub-script-check
126.76
KB
-rwxr-xr-x
grub-syslinux2cfg
698.71
KB
-rwxr-xr-x
gsettings
30.3
KB
-rwxr-xr-x
gtbl
134.48
KB
-rwxr-xr-x
gunzip
2.29
KB
-rwxr-xr-x
gzexe
6.3
KB
-rwxr-xr-x
gzip
91.23
KB
-rwxr-xr-x
h2ph
28.54
KB
-rwxr-xr-x
h2xs
59.51
KB
-rwxr-xr-x
hardlink
46.48
KB
-rwxr-xr-x
hd
46.39
KB
-rwxr-xr-x
head
42.51
KB
-rwxr-xr-x
helpztags
2.46
KB
-rwxr-xr-x
hexdump
46.39
KB
-rwxr-xr-x
host
118.82
KB
-rwxr-xr-x
hostid
34.51
KB
-rwxr-xr-x
hostname
22.23
KB
-rwxr-xr-x
hostnamectl
30.45
KB
-rwxr-xr-x
htcacheclean
34.31
KB
-rwxr-xr-x
htdbm
26.3
KB
-rwxr-xr-x
htdigest
14.3
KB
-rwxr-xr-x
htop
370.33
KB
-rwxr-xr-x
htpasswd
26.3
KB
-rwxr-xr-x
hwe-support-status
11.24
KB
-rwxr-xr-x
i386
26.65
KB
-rwxr-xr-x
iconv
66.48
KB
-rwxr-xr-x
id
38.51
KB
-rwxr-xr-x
ifstat
34.31
KB
-rwxr-xr-x
inetutils-telnet
177.85
KB
-rwxr-xr-x
info
241.73
KB
-rwxr-xr-x
infobrowser
241.73
KB
-rwxr-xr-x
infocmp
66.38
KB
-rwxr-xr-x
infotocap
90.41
KB
-rwxr-xr-x
innochecksum
4.57
MB
-rwxr-xr-x
innotop
445.71
KB
-rwxr-xr-x
install
142.52
KB
-rwxr-xr-x
install-info
47.24
KB
-rwxr-xr-x
instmodsh
4.27
KB
-rwxr-xr-x
ionice
18.38
KB
-rwxr-xr-x
iostat
54.44
KB
-rwxr-xr-x
ip
754.8
KB
-rwxr-xr-x
ipcmk
22.45
KB
-rwxr-xr-x
ipcrm
18.38
KB
-rwxr-xr-x
ipcs
38.38
KB
-rwxr-xr-x
iperf3
14.15
KB
-rwxr-xr-x
iptables-xml
92.95
KB
-rwxr-xr-x
ischroot
14.48
KB
-rwxr-xr-x
iscsiadm
370.43
KB
-rwxr-xr-x
join
50.55
KB
-rwxr-xr-x
journalctl
78.91
KB
-rwxr-xr-x
jq
30.15
KB
-rwxr-xr-x
json-patch-jsondiff
1004
B
-rwxr-xr-x
json_pp
4.88
KB
-rwxr-xr-x
jsondiff
1004
B
-rwxr-xr-x
jsonpatch
3.77
KB
-rwxr-xr-x
jsonpointer
1.79
KB
-rwxr-xr-x
jsonschema
213
B
-rwxr-xr-x
kbd_mode
14.66
KB
-rwxr-xr-x
kbdinfo
18.37
KB
-rwxr-xr-x
kbxutil
62.83
KB
-rwxr-xr-x
keep-one-running
3.51
KB
-rwxr-xr-x
kernel-install
54.67
KB
-rwxr-xr-x
kill
22.38
KB
-rwxr-xr-x
killall
31.34
KB
-rwxr-xr-x
kmod
170.24
KB
-rwxr-xr-x
kmodsign
18.45
KB
-rwxr-xr-x
landscape-sysinfo
646
B
-rwxr-xr-x
last
34.38
KB
-rwxr-xr-x
lastb
34.38
KB
-rwxr-xr-x
lastlog
27.79
KB
-rwxr-xr-x
lcf
7.6
KB
-rwxr-xr-x
ld.so
231.07
KB
-rwxr-xr-x
ldd
5.26
KB
-rwxr-xr-x
less
190.38
KB
-rwxr-xr-x
lessecho
14.31
KB
-rwxr-xr-x
lessfile
8.83
KB
-rwxr-xr-x
lesskey
23.7
KB
-rwxr-xr-x
lesspipe
8.83
KB
-rwxr-xr-x
letsencrypt
958
B
-rwxr-xr-x
lexgrog
99.51
KB
-rwxr-xr-x
libnetcfg
15.41
KB
-rwxr-xr-x
link
34.51
KB
-rwxr-xr-x
linux-boot-prober
1.54
KB
-rwxr-xr-x
linux-check-removal
3.99
KB
-rwxr-xr-x
linux-update-symlinks
6.17
KB
-rwxr-xr-x
linux-version
2.63
KB
-rwxr-xr-x
linux32
26.65
KB
-rwxr-xr-x
linux64
26.65
KB
-rwxr-xr-x
ln
54.51
KB
-rwxr-xr-x
lnstat
22.66
KB
-rwxr-xr-x
loadkeys
202.9
KB
-rwxr-xr-x
loadunimap
34.46
KB
-rwxr-xr-x
locale
49.63
KB
-rwxr-xr-x
locale-check
14.15
KB
-rwxr-xr-x
localectl
26.45
KB
-rwxr-xr-x
localedef
319.09
KB
-rwxr-xr-x
logger
38.97
KB
-rwxr-xr-x
login
51.81
KB
-rwxr-xr-x
loginctl
66.58
KB
-rwxr-xr-x
logname
34.51
KB
-rwxr-xr-x
logresolve
14.31
KB
-rwxr-xr-x
look
18.38
KB
-rwxr-xr-x
lowntfs-3g
118.98
KB
-rwxr-xr-x
ls
138.98
KB
-rwxr-xr-x
lsattr
14.31
KB
-rwxr-xr-x
lsb_release
2.59
KB
-rwxr-xr-x
lsblk
146.38
KB
-rwxr-xr-x
lscpu
110.38
KB
-rwxr-xr-x
lshw
957.2
KB
-rwxr-xr-x
lsinitramfs
735
B
-rwxr-xr-x
lsipc
50.38
KB
-rwxr-xr-x
lslocks
30.77
KB
-rwxr-xr-x
lslogins
50.38
KB
-rwxr-xr-x
lsmem
38.38
KB
-rwxr-xr-x
lsmod
170.24
KB
-rwxr-xr-x
lsns
42.38
KB
-rwxr-xr-x
lsof
171.66
KB
-rwxr-xr-x
lspci
100.11
KB
-rwxr-xr-x
lspgpot
1.06
KB
-rwxr-xr-x
lspower
1.18
KB
-rwxr-xr-x
lsusb
246.52
KB
-rwxr-xr-x
lzcat
86.92
KB
-rwxr-xr-x
lzcmp
7.25
KB
-rwxr-xr-x
lzdiff
7.25
KB
-rwxr-xr-x
lzegrep
10.09
KB
-rwxr-xr-x
lzfgrep
10.09
KB
-rwxr-xr-x
lzgrep
10.09
KB
-rwxr-xr-x
lzless
1.77
KB
-rwxr-xr-x
lzma
86.92
KB
-rwxr-xr-x
lzmainfo
14.38
KB
-rwxr-xr-x
lzmore
2.14
KB
-rwxr-xr-x
mailmail3
227
B
-rwxr-xr-x
man
125.41
KB
-rwxr-xr-x
man-recode
35.4
KB
-rwxr-xr-x
mandb
143.67
KB
-rwxr-xr-x
manifest
1.9
KB
-rwxr-xr-x
manpath
26.78
KB
-rwxr-xr-x
mapscrn
30.46
KB
-rwxr-xr-x
mariadb
5.07
MB
-rwxr-xr-x
mariadb-access
109.31
KB
-rwxr-xr-x
mariadb-admin
4.85
MB
-rwxr-xr-x
mariadb-analyze
4.84
MB
-rwxr-xr-x
mariadb-binlog
5.13
MB
-rwxr-xr-x
mariadb-check
4.84
MB
-rwxr-xr-x
mariadb-conv
4.56
MB
-rwxr-xr-x
mariadb-convert-table-format
4.12
KB
-rwxr-xr-x
mariadb-dump
4.93
MB
-rwxr-xr-x
mariadb-dumpslow
8.05
KB
-rwxr-xr-x
mariadb-find-rows
3.21
KB
-rwxr-xr-x
mariadb-fix-extensions
1.22
KB
-rwxr-xr-x
mariadb-hotcopy
34.53
KB
-rwxr-xr-x
mariadb-import
4.83
MB
-rwxr-xr-x
mariadb-install-db
22.13
KB
-rwxr-xr-x
mariadb-optimize
4.84
MB
-rwxr-xr-x
mariadb-plugin
4.54
MB
-rwxr-xr-x
mariadb-repair
4.84
MB
-rwxr-xr-x
mariadb-report
49.02
KB
-rwxr-xr-x
mariadb-secure-installation
13.49
KB
-rwxr-xr-x
mariadb-service-convert
2.45
KB
-rwxr-xr-x
mariadb-setpermission
17.56
KB
-rwxr-xr-x
mariadb-show
4.83
MB
-rwxr-xr-x
mariadb-slap
4.85
MB
-rwxr-xr-x
mariadb-tzinfo-to-sql
4.53
MB
-rwxr-xr-x
mariadb-upgrade
4.97
MB
-rwxr-xr-x
mariadb-waitpid
4.53
MB
-rwxr-xr-x
mariadbcheck
4.84
MB
-rwxr-xr-x
mariadbd-multi
26.69
KB
-rwxr-xr-x
mariadbd-safe
30.42
KB
-rwxr-xr-x
mariadbd-safe-helper
4.49
MB
-rwxr-xr-x
markdown-it
220
B
-rwxr-xr-x
mawk
166.77
KB
-rwxr-xr-x
mbim-network
11.08
KB
-rwxr-xr-x
mbimcli
216.65
KB
-rwxr-xr-x
mcookie
26.45
KB
-rwxr-xr-x
md5sum
38.41
KB
-rwxr-xr-x
md5sum.textutils
38.41
KB
-rwxr-xr-x
mdig
50.4
KB
-rwxr-xr-x
memhog
14.42
KB
-rwxr-xr-x
memusage
7.32
KB
-rwxr-xr-x
memusagestat
22.44
KB
-rwxr-xr-x
mesg
14.38
KB
-rwxr-xr-x
migrate-pubring-from-classic-g...
3.02
KB
-rwxr-xr-x
migratepages
14.38
KB
-rwxr-xr-x
migspeed
14.3
KB
-rwxr-xr-x
mk_modmap
15.78
KB
-rwxr-xr-x
mkdir
74.51
KB
-rwxr-xr-x
mkfifo
42.51
KB
-rwxr-xr-x
mknod
42.51
KB
-rwxr-xr-x
mkpasswd
26.38
KB
-rwxr-xr-x
mksquashfs
286.95
KB
-rwxr-xr-x
mktemp
34.51
KB
-rwxr-xr-x
mmcli
273.94
KB
-rwxr-xr-x
mokutil
59.48
KB
-rwxr-xr-x
more
46.38
KB
-rwxr-xr-x
mount
50.38
KB
-rwsr-xr-x
mountpoint
18.38
KB
-rwxr-xr-x
mpstat
50.45
KB
-rwxr-xr-x
msql2mysql
1.41
KB
-rwxr-xr-x
mt
70.73
KB
-rwxr-xr-x
mt-gnu
70.73
KB
-rwxr-xr-x
mtr
76.25
KB
-rwxr-xr-x
mtr-packet
34.3
KB
-rwxr-xr-x
mtrace
6.37
KB
-rwxr-xr-x
mv
134.52
KB
-rwxr-xr-x
my_print_defaults
4.53
MB
-rwxr-xr-x
myisam_ftdump
4.87
MB
-rwxr-xr-x
myisamchk
4.99
MB
-rwxr-xr-x
myisamlog
4.85
MB
-rwxr-xr-x
myisampack
4.9
MB
-rwxr-xr-x
mysql
5.07
MB
-rwxr-xr-x
mysql_convert_table_format
4.12
KB
-rwxr-xr-x
mysql_find_rows
3.21
KB
-rwxr-xr-x
mysql_fix_extensions
1.22
KB
-rwxr-xr-x
mysql_install_db
22.13
KB
-rwxr-xr-x
mysql_plugin
4.54
MB
-rwxr-xr-x
mysql_secure_installation
13.49
KB
-rwxr-xr-x
mysql_setpermission
17.56
KB
-rwxr-xr-x
mysql_tzinfo_to_sql
4.53
MB
-rwxr-xr-x
mysql_upgrade
4.97
MB
-rwxr-xr-x
mysql_waitpid
4.53
MB
-rwxr-xr-x
mysqlaccess
109.31
KB
-rwxr-xr-x
mysqladmin
4.85
MB
-rwxr-xr-x
mysqlanalyze
4.84
MB
-rwxr-xr-x
mysqlbinlog
5.13
MB
-rwxr-xr-x
mysqlcheck
4.84
MB
-rwxr-xr-x
mysqld_multi
26.69
KB
-rwxr-xr-x
mysqld_safe
30.42
KB
-rwxr-xr-x
mysqld_safe_helper
4.49
MB
-rwxr-xr-x
mysqldump
4.93
MB
-rwxr-xr-x
mysqldumpslow
8.05
KB
-rwxr-xr-x
mysqlhotcopy
34.53
KB
-rwxr-xr-x
mysqlimport
4.83
MB
-rwxr-xr-x
mysqloptimize
4.84
MB
-rwxr-xr-x
mysqlrepair
4.84
MB
-rwxr-xr-x
mysqlreport
49.02
KB
-rwxr-xr-x
mysqlshow
4.83
MB
-rwxr-xr-x
mysqlslap
4.85
MB
-rwxr-xr-x
mytop
71.95
KB
-rwxr-xr-x
namei
22.38
KB
-rwxr-xr-x
nano
272.5
KB
-rwxr-xr-x
nawk
722.5
KB
-rwxr-xr-x
nc
38.63
KB
-rwxr-xr-x
nc.openbsd
38.63
KB
-rwxr-xr-x
neqn
913
B
-rwxr-xr-x
netaddr
959
B
-rwxr-xr-x
netcat
38.63
KB
-rwxr-xr-x
netstat
154.59
KB
-rwxr-xr-x
networkctl
122.58
KB
-rwxr-xr-x
networkd-dispatcher
19.88
KB
-rwxr-xr-x
newgrp
39.71
KB
-rwsr-xr-x
ngettext
34.38
KB
-rwxr-xr-x
nice
34.51
KB
-rwxr-xr-x
nisdomainname
22.23
KB
-rwxr-xr-x
nl
38.6
KB
-rwxr-xr-x
nohup
34.41
KB
-rwxr-xr-x
nproc
34.51
KB
-rwxr-xr-x
nroff
5.58
KB
-rwxr-xr-x
nsenter
30.6
KB
-rwxr-xr-x
nslookup
122.82
KB
-rwxr-xr-x
nstat
30.38
KB
-rwxr-xr-x
nsupdate
74.55
KB
-rwxr-xr-x
ntfs-3g
159.01
KB
-rwxr-xr-x
ntfs-3g.probe
14.38
KB
-rwxr-xr-x
ntfscat
26.38
KB
-rwxr-xr-x
ntfscluster
38.38
KB
-rwxr-xr-x
ntfscmp
30.38
KB
-rwxr-xr-x
ntfsdecrypt
42.38
KB
-rwxr-xr-x
ntfsfallocate
26.38
KB
-rwxr-xr-x
ntfsfix
34.38
KB
-rwxr-xr-x
ntfsinfo
54.38
KB
-rwxr-xr-x
ntfsls
27.45
KB
-rwxr-xr-x
ntfsmove
30.38
KB
-rwxr-xr-x
ntfsrecover
102.38
KB
-rwxr-xr-x
ntfssecaudit
78.86
KB
-rwxr-xr-x
ntfstruncate
26.3
KB
-rwxr-xr-x
ntfsusermap
18.3
KB
-rwxr-xr-x
ntfswipe
46.91
KB
-rwxr-xr-x
numactl
35.23
KB
-rwxr-xr-x
numastat
35.56
KB
-rwxr-xr-x
numfmt
58.54
KB
-rwxr-xr-x
od
70.51
KB
-rwxr-xr-x
oem-getlogs
8.3
KB
-rwxr-xr-x
on_ac_power
3.7
KB
-rwxr-xr-x
openssl
981.8
KB
-rwxr-xr-x
openvt
22.73
KB
-rwxr-xr-x
os-prober
4.42
KB
-rwxr-xr-x
pager
190.38
KB
-rwxr-xr-x
partx
62.38
KB
-rwxr-xr-x
passwd
62.65
KB
-rwsr-xr-x
paste
38.41
KB
-rwxr-xr-x
pastebinit
16.31
KB
-rwxr-xr-x
patch
182.52
KB
-rwxr-xr-x
pathchk
34.51
KB
-rwxr-xr-x
pbget
2.51
KB
-rwxr-xr-x
pbput
2.51
KB
-rwxr-xr-x
pbputs
2.51
KB
-rwxr-xr-x
pcp
5.3
KB
-rwxr-xr-x
pcp2csv
65.89
KB
-rwxr-xr-x
pdb3
67.83
KB
-rwxr-xr-x
pdb3.12
67.83
KB
-rwxr-xr-x
peekfd
14.3
KB
-rwxr-xr-x
perf
1.58
KB
-rwxr-xr-x
perl
3.83
MB
-rwxr-xr-x
perl5.38-x86_64-linux-gnu
14.3
KB
-rwxr-xr-x
perl5.38.2
3.83
MB
-rwxr-xr-x
perlbug
44.52
KB
-rwxr-xr-x
perldoc
125
B
-rwxr-xr-x
perlivp
10.61
KB
-rwxr-xr-x
perlthanks
44.52
KB
-rwxr-xr-x
perror
4.72
MB
-rwxr-xr-x
pgrep
34.47
KB
-rwxr-xr-x
phar
14.84
KB
-rwxr-xr-x
phar.default
14.84
KB
-rwxr-xr-x
phar.phar
14.84
KB
-rwxr-xr-x
phar.phar.default
14.84
KB
-rwxr-xr-x
phar.phar8.3
14.84
KB
-rwxr-xr-x
phar8.3
14.84
KB
-rwxr-xr-x
phar8.3.phar
14.84
KB
-rwxr-xr-x
php
5.52
MB
-rwxr-xr-x
php.default
5.52
MB
-rwxr-xr-x
php8.3
5.52
MB
-rwxr-xr-x
pic
196.06
KB
-rwxr-xr-x
pico
272.5
KB
-rwxr-xr-x
piconv
8.16
KB
-rwxr-xr-x
pidof
26.23
KB
-rwxr-xr-x
pidstat
50.45
KB
-rwxr-xr-x
pidwait
34.47
KB
-rwxr-xr-x
pinentry
58.65
KB
-rwxr-xr-x
pinentry-curses
58.65
KB
-rwxr-xr-x
ping
87.7
KB
-rwxr-xr-x
ping4
87.7
KB
-rwxr-xr-x
ping6
87.7
KB
-rwxr-xr-x
pinky
38.41
KB
-rwxr-xr-x
pkaction
18.3
KB
-rwxr-xr-x
pkcheck
22.3
KB
-rwxr-xr-x
pkcon
54.3
KB
-rwxr-xr-x
pkill
34.47
KB
-rwxr-xr-x
pkmon
22.3
KB
-rwxr-xr-x
pkttyagent
22.3
KB
-rwxr-xr-x
pl2pm
4.43
KB
-rwxr-xr-x
pldd
22.44
KB
-rwxr-xr-x
plymouth
46.3
KB
-rwxr-xr-x
pmafm
11.84
KB
-rwxr-xr-x
pmap
34.4
KB
-rwxr-xr-x
pmclient
22.92
KB
-rwxr-xr-x
pmclient_fg
18.91
KB
-rwxr-xr-x
pmdate
14.02
KB
-rwxr-xr-x
pmdbg
22.58
KB
-rwxr-xr-x
pmdiff
7.63
KB
-rwxr-xr-x
pmdumplog
35.13
KB
-rwxr-xr-x
pmerr
14.02
KB
-rwxr-xr-x
pmevent
43.38
KB
-rwxr-xr-x
pmfind
22.7
KB
-rwxr-xr-x
pmgenmap
2.38
KB
-rwxr-xr-x
pmie
197.95
KB
-rwxr-xr-x
pmie2col
2.81
KB
-rwxr-xr-x
pmieconf
56.77
KB
-rwxr-xr-x
pmiectl
46
KB
-rwxr-xr-x
pminfo
47.29
KB
-rwxr-xr-x
pmiostat
20.79
KB
-rwxr-xr-x
pmjson
14.63
KB
-rwxr-xr-x
pmlc
55.86
KB
-rwxr-xr-x
pmlogcheck
38.7
KB
-rwxr-xr-x
pmlogconf
55.26
KB
-rwxr-xr-x
pmlogctl
46
KB
-rwxr-xr-x
pmlogdump
35.13
KB
-rwxr-xr-x
pmlogextract
74.88
KB
-rwxr-xr-x
pmlogger
159.62
KB
-rwxr-xr-x
pmloglabel
22.63
KB
-rwxr-xr-x
pmlogmv
18.54
KB
-rwxr-xr-x
pmlogpaste
18.57
KB
-rwxr-xr-x
pmlogredact
1.79
KB
-rwxr-xr-x
pmlogreduce
30.7
KB
-rwxr-xr-x
pmlogrewrite
158.76
KB
-rwxr-xr-x
pmlogsize
26.54
KB
-rwxr-xr-x
pmlogsummary
35.13
KB
-rwxr-xr-x
pmprobe
23.04
KB
-rwxr-xr-x
pmpython
14.02
KB
-rwxr-xr-x
pmrep
65.89
KB
-rwxr-xr-x
pmrepconf
55.26
KB
-rwxr-xr-x
pmsearch
22.91
KB
-rwxr-xr-x
pmseries
39.16
KB
-rwxr-xr-x
pmsocks
1010
B
-rwxr-xr-x
pmstat
27.07
KB
-rwxr-xr-x
pmstore
18.7
KB
-rwxr-xr-x
pmtrace
14.02
KB
-rwxr-xr-x
pmval
43.38
KB
-rwxr-xr-x
pod2html
3.95
KB
-rwxr-xr-x
pod2man
18.46
KB
-rwxr-xr-x
pod2text
12.8
KB
-rwxr-xr-x
pod2usage
4.01
KB
-rwxr-xr-x
podchecker
3.57
KB
-rwxr-xr-x
pollinate
8.54
KB
-rwxr-xr-x
pr
70.58
KB
-rwxr-xr-x
preconv
58.48
KB
-rwxr-xr-x
printenv
34.38
KB
-rwxr-xr-x
printf
54.44
KB
-rwxr-xr-x
prlimit
26.89
KB
-rwxr-xr-x
pro
1003
B
-rwxr-xr-x
procan
42.41
KB
-rwxr-xr-x
prove
13.34
KB
-rwxr-xr-x
prtstat
18.38
KB
-rwxr-xr-x
ps
142.99
KB
-rwxr-xr-x
psfaddtable
22.37
KB
-rwxr-xr-x
psfgettable
22.37
KB
-rwxr-xr-x
psfstriptable
22.37
KB
-rwxr-xr-x
psfxtable
22.37
KB
-rwxr-xr-x
pslog
14.3
KB
-rwxr-xr-x
pstree
35.32
KB
-rwxr-xr-x
pstree.x11
35.32
KB
-rwxr-xr-x
ptar
3.48
KB
-rwxr-xr-x
ptardiff
2.58
KB
-rwxr-xr-x
ptargrep
4.29
KB
-rwxr-xr-x
ptx
54.54
KB
-rwxr-xr-x
purge-old-kernels
1.12
KB
-rwxr-xr-x
pv
79.41
KB
-rwxr-xr-x
pwd
34.51
KB
-rwxr-xr-x
pwdx
14.38
KB
-rwxr-xr-x
py3clean
7.63
KB
-rwxr-xr-x
py3compile
13
KB
-rwxr-xr-x
py3versions
12.52
KB
-rwxr-xr-x
pybabel
956
B
-rwxr-xr-x
pybabel-python3
956
B
-rwxr-xr-x
pydoc3
80
B
-rwxr-xr-x
pydoc3.12
80
B
-rwxr-xr-x
pygettext3
23.66
KB
-rwxr-xr-x
pygettext3.12
23.66
KB
-rwxr-xr-x
pygmentize
215
B
-rwxr-xr-x
pyhtmlizer3
222
B
-rwxr-xr-x
pyserial-miniterm
975
B
-rwxr-xr-x
pyserial-ports
969
B
-rwxr-xr-x
python3
7.65
MB
-rwxr-xr-x
python3.12
7.65
MB
-rwxr-xr-x
pzstd
690.54
KB
-rwxr-xr-x
qmi-firmware-update
168.09
KB
-rwxr-xr-x
qmi-network
16.04
KB
-rwxr-xr-x
qmicli
586.84
KB
-rwxr-xr-x
rbash
1.38
MB
-rwxr-xr-x
rdma
102.52
KB
-rwxr-xr-x
readlink
42.41
KB
-rwxr-xr-x
realpath
42.41
KB
-rwxr-xr-x
red
89
B
-rwxr-xr-x
rename.ul
22.38
KB
-rwxr-xr-x
renice
14.38
KB
-rwxr-xr-x
replace
4.51
MB
-rwxr-xr-x
rescan-scsi-bus.sh
38.05
KB
-rwxr-xr-x
reset
26.31
KB
-rwxr-xr-x
resizecons
26.46
KB
-rwxr-xr-x
resizepart
22.38
KB
-rwxr-xr-x
resolve_stack_dump
4.53
MB
-rwxr-xr-x
resolvectl
158.67
KB
-rwxr-xr-x
resolveip
4.53
MB
-rwxr-xr-x
rev
14.38
KB
-rwxr-xr-x
rgrep
30
B
-rwxr-xr-x
rm
58.51
KB
-rwxr-xr-x
rmdir
46.41
KB
-rwxr-xr-x
rnano
272.5
KB
-rwxr-xr-x
rotatelogs
26.38
KB
-rwxr-xr-x
routel
1.62
KB
-rwxr-xr-x
rpcgen
94.59
KB
-rwxr-xr-x
rrsync
12.34
KB
-rwxr-xr-x
rsync
502.13
KB
-rwxr-xr-x
rsync-ssl
5.02
KB
-rwxr-xr-x
rtla
1.58
KB
-rwxr-xr-x
rtstat
22.66
KB
-rwxr-xr-x
run-one
3.51
KB
-rwxr-xr-x
run-one-constantly
3.51
KB
-rwxr-xr-x
run-one-until-failure
3.51
KB
-rwxr-xr-x
run-one-until-success
3.51
KB
-rwxr-xr-x
run-parts
26.82
KB
-rwxr-xr-x
run-this-one
3.51
KB
-rwxr-xr-x
runcon
34.51
KB
-rwxr-xr-x
rview
3.94
MB
-rwxr-xr-x
rvim
3.94
MB
-rwxr-xr-x
sadf
382.31
KB
-rwxr-xr-x
sar
137.38
KB
-rwxr-xr-x
sar.sysstat
137.38
KB
-rwxr-xr-x
savelog
10.24
KB
-rwxr-xr-x
sbattach
22.54
KB
-rwxr-xr-x
sbkeysync
34.74
KB
-rwxr-xr-x
sbsiglist
14.6
KB
-rwxr-xr-x
sbsign
34.7
KB
-rwxr-xr-x
sbvarsign
22.73
KB
-rwxr-xr-x
sbverify
30.61
KB
-rwxr-xr-x
scalar
668.94
KB
-rwxr-xr-x
scandeps
6.47
KB
-rwxr-xr-x
scp
134.59
KB
-rwxr-xr-x
screen
478.24
KB
-rwxr-xr-x
screendump
14.3
KB
-rwxr-xr-x
script
54.38
KB
-rwxr-xr-x
scriptlive
42.38
KB
-rwxr-xr-x
scriptreplay
34.38
KB
-rwxr-xr-x
scsi_logging_level
8.38
KB
-rwxr-xr-x
scsi_mandat
3.52
KB
-rwxr-xr-x
scsi_readcap
1.3
KB
-rwxr-xr-x
scsi_ready
1.09
KB
-rwxr-xr-x
scsi_satl
3.74
KB
-rwxr-xr-x
scsi_start
1.25
KB
-rwxr-xr-x
scsi_stop
1.44
KB
-rwxr-xr-x
scsi_temperature
936
B
-rwxr-xr-x
sdiff
50.39
KB
-rwxr-xr-x
sed
110.57
KB
-rwxr-xr-x
select-editor
2.39
KB
-rwxr-xr-x
sensible-browser
1.55
KB
-rwxr-xr-x
sensible-editor
1.52
KB
-rwxr-xr-x
sensible-pager
921
B
-rwxr-xr-x
sensible-terminal
1.15
KB
-rwxr-xr-x
seq
50.51
KB
-rwxr-xr-x
setarch
26.65
KB
-rwxr-xr-x
setfont
54.46
KB
-rwxr-xr-x
setkeycodes
14.37
KB
-rwxr-xr-x
setleds
18.43
KB
-rwxr-xr-x
setlogcons
14.37
KB
-rwxr-xr-x
setmetamode
14.41
KB
-rwxr-xr-x
setpci
30.38
KB
-rwxr-xr-x
setpriv
38.38
KB
-rwxr-xr-x
setsid
14.38
KB
-rwxr-xr-x
setterm
34.38
KB
-rwxr-xr-x
setupcon
40.06
KB
-rwxr-xr-x
sftp
150.66
KB
-rwxr-xr-x
sg
39.71
KB
-rwsr-xr-x
sg_bg_ctl
14.51
KB
-rwxr-xr-x
sg_compare_and_write
26.91
KB
-rwxr-xr-x
sg_copy_results
23.3
KB
-rwxr-xr-x
sg_dd
54.33
KB
-rwxr-xr-x
sg_decode_sense
14.76
KB
-rwxr-xr-x
sg_emc_trespass
14.3
KB
-rwxr-xr-x
sg_format
39.35
KB
-rwxr-xr-x
sg_get_config
35.38
KB
-rwxr-xr-x
sg_get_elem_status
26.79
KB
-rwxr-xr-x
sg_get_lba_status
22.95
KB
-rwxr-xr-x
sg_ident
14.6
KB
-rwxr-xr-x
sg_inq
115.61
KB
-rwxr-xr-x
sg_logs
146.93
KB
-rwxr-xr-x
sg_luns
22.79
KB
-rwxr-xr-x
sg_map
18.3
KB
-rwxr-xr-x
sg_map26
26.7
KB
-rwxr-xr-x
sg_modes
46.08
KB
-rwxr-xr-x
sg_opcodes
35.01
KB
-rwxr-xr-x
sg_persist
36.08
KB
-rwxr-xr-x
sg_prevent
14.51
KB
-rwxr-xr-x
sg_raw
26.91
KB
-rwxr-xr-x
sg_rbuf
22.73
KB
-rwxr-xr-x
sg_rdac
18.3
KB
-rwxr-xr-x
sg_read
26.31
KB
-rwxr-xr-x
sg_read_attr
36.65
KB
-rwxr-xr-x
sg_read_block_limits
14.54
KB
-rwxr-xr-x
sg_read_buffer
27.56
KB
-rwxr-xr-x
sg_read_long
14.7
KB
-rwxr-xr-x
sg_readcap
22.79
KB
-rwxr-xr-x
sg_reassign
18.66
KB
-rwxr-xr-x
sg_referrals
14.66
KB
-rwxr-xr-x
sg_rep_pip
14.57
KB
-rwxr-xr-x
sg_rep_zones
26.8
KB
-rwxr-xr-x
sg_requests
22.76
KB
-rwxr-xr-x
sg_reset
14.66
KB
-rwxr-xr-x
sg_reset_wp
14.6
KB
-rwxr-xr-x
sg_rmsn
14.51
KB
-rwxr-xr-x
sg_rtpg
14.6
KB
-rwxr-xr-x
sg_safte
22.7
KB
-rwxr-xr-x
sg_sanitize
27.01
KB
-rwxr-xr-x
sg_sat_identify
18.73
KB
-rwxr-xr-x
sg_sat_phy_event
19.01
KB
-rwxr-xr-x
sg_sat_read_gplog
18.73
KB
-rwxr-xr-x
sg_sat_set_features
18.7
KB
-rwxr-xr-x
sg_scan
18.38
KB
-rwxr-xr-x
sg_seek
18.88
KB
-rwxr-xr-x
sg_senddiag
27.2
KB
-rwxr-xr-x
sg_ses
119.97
KB
-rwxr-xr-x
sg_ses_microcode
27.36
KB
-rwxr-xr-x
sg_start
18.85
KB
-rwxr-xr-x
sg_stpg
22.73
KB
-rwxr-xr-x
sg_stream_ctl
18.7
KB
-rwxr-xr-x
sg_sync
14.66
KB
-rwxr-xr-x
sg_test_rwbuf
18.6
KB
-rwxr-xr-x
sg_timestamp
22.83
KB
-rwxr-xr-x
sg_turs
26.7
KB
-rwxr-xr-x
sg_unmap
22.76
KB
-rwxr-xr-x
sg_verify
22.91
KB
-rwxr-xr-x
sg_vpd
118.42
KB
-rwxr-xr-x
sg_wr_mode
22.73
KB
-rwxr-xr-x
sg_write_buffer
27.23
KB
-rwxr-xr-x
sg_write_long
14.76
KB
-rwxr-xr-x
sg_write_same
26.95
KB
-rwxr-xr-x
sg_write_verify
26.79
KB
-rwxr-xr-x
sg_write_x
55.6
KB
-rwxr-xr-x
sg_xcopy
42.32
KB
-rwxr-xr-x
sg_zone
14.86
KB
-rwxr-xr-x
sginfo
76.01
KB
-rwxr-xr-x
sgm_dd
34.31
KB
-rwxr-xr-x
sgp_dd
46.31
KB
-rwxr-xr-x
sh
126.74
KB
-rwxr-xr-x
sha1sum
38.41
KB
-rwxr-xr-x
sha224sum
38.41
KB
-rwxr-xr-x
sha256sum
38.41
KB
-rwxr-xr-x
sha384sum
38.41
KB
-rwxr-xr-x
sha512sum
38.41
KB
-rwxr-xr-x
shasum
9.75
KB
-rwxr-xr-x
showconsolefont
18.37
KB
-rwxr-xr-x
showkey
18.37
KB
-rwxr-xr-x
shred
54.51
KB
-rwxr-xr-x
shuf
46.51
KB
-rwxr-xr-x
sigtool
6.74
MB
-rwxr-xr-x
skill
26.41
KB
-rwxr-xr-x
slabtop
22.44
KB
-rwxr-xr-x
sleep
34.51
KB
-rwxr-xr-x
slogin
827.04
KB
-rwxr-xr-x
snap
20.64
MB
-rwxr-xr-x
snapctl
7.29
MB
-rwxr-xr-x
snapfuse
38.23
KB
-rwxr-xr-x
snice
26.41
KB
-rwxr-xr-x
socat
447.68
KB
-rwxr-xr-x
socat-broker.sh
2.24
KB
-rwxr-xr-x
socat-chain.sh
7.86
KB
-rwxr-xr-x
socat-mux.sh
3.47
KB
-rwxr-xr-x
socat1
447.68
KB
-rwxr-xr-x
soelim
34.48
KB
-rwxr-xr-x
sort
102.8
KB
-rwxr-xr-x
sos
612
B
-rwxr-xr-x
sos-collector
1.04
KB
-rwxr-xr-x
sosreport
1.03
KB
-rwxr-xr-x
sotruss
4.21
KB
-rwxr-xr-x
speedtest
980
B
-rwxr-xr-x
speedtest-cli
988
B
-rwxr-xr-x
splain
18.99
KB
-rwxr-xr-x
split
54.94
KB
-rwxr-xr-x
splitfont
14.3
KB
-rwxr-xr-x
sprof
34.44
KB
-rwxr-xr-x
sqfscat
147.9
KB
-rwxr-xr-x
sqfstar
286.95
KB
-rwxr-xr-x
ss
129.07
KB
-rwxr-xr-x
ssh
827.04
KB
-rwxr-xr-x
ssh-add
294.42
KB
-rwxr-xr-x
ssh-agent
302.43
KB
-rwxr-sr-x
ssh-argv0
1.42
KB
-rwxr-xr-x
ssh-copy-id
12.77
KB
-rwxr-xr-x
ssh-import-id
985
B
-rwxr-xr-x
ssh-import-id-gh
785
B
-rwxr-xr-x
ssh-import-id-lp
785
B
-rwxr-xr-x
ssh-keygen
442.44
KB
-rwxr-xr-x
ssh-keyscan
330.44
KB
-rwxr-xr-x
stat
86.52
KB
-rwxr-xr-x
static-sh
2.03
MB
-rwxr-xr-x
stdbuf
50.51
KB
-rwxr-xr-x
strace
1.99
MB
-rwxr-xr-x
strace-log-merge
1.78
KB
-rwxr-xr-x
streamzip
7.87
KB
-rwxr-xr-x
stty
78.52
KB
-rwxr-xr-x
su
54.38
KB
-rwsr-xr-x
sudo
271.42
KB
-rwsr-xr-x
sudoedit
271.42
KB
-rwsr-xr-x
sudoreplay
95.95
KB
-rwxr-xr-x
sum
34.41
KB
-rwxr-xr-x
sync
34.41
KB
-rwxr-xr-x
systemctl
1.43
MB
-rwxr-xr-x
systemd
98.45
KB
-rwxr-xr-x
systemd-ac-power
14.45
KB
-rwxr-xr-x
systemd-analyze
198.85
KB
-rwxr-xr-x
systemd-ask-password
18.58
KB
-rwxr-xr-x
systemd-cat
18.45
KB
-rwxr-xr-x
systemd-cgls
22.57
KB
-rwxr-xr-x
systemd-cgtop
38.47
KB
-rwxr-xr-x
systemd-confext
54.64
KB
-rwxr-xr-x
systemd-creds
42.72
KB
-rwxr-xr-x
systemd-cryptenroll
70.92
KB
-rwxr-xr-x
systemd-cryptsetup
78.95
KB
-rwxr-xr-x
systemd-delta
26.45
KB
-rwxr-xr-x
systemd-detect-virt
18.45
KB
-rwxr-xr-x
systemd-escape
22.45
KB
-rwxr-xr-x
systemd-firstboot
58.82
KB
-rwxr-xr-x
systemd-hwdb
154.74
KB
-rwxr-xr-x
systemd-id128
22.45
KB
-rwxr-xr-x
systemd-inhibit
22.47
KB
-rwxr-xr-x
systemd-machine-id-setup
18.63
KB
-rwxr-xr-x
systemd-mount
50.78
KB
-rwxr-xr-x
systemd-notify
26.66
KB
-rwxr-xr-x
systemd-path
18.45
KB
-rwxr-xr-x
systemd-repart
195.23
KB
-rwxr-xr-x
systemd-run
66.79
KB
-rwxr-xr-x
systemd-socket-activate
30.45
KB
-rwxr-xr-x
systemd-stdio-bridge
22.45
KB
-rwxr-xr-x
systemd-sysext
54.64
KB
-rwxr-xr-x
systemd-sysusers
66.63
KB
-rwxr-xr-x
systemd-tmpfiles
114.7
KB
-rwxr-xr-x
systemd-tty-ask-password-agent
34.45
KB
-rwxr-xr-x
systemd-umount
50.78
KB
-rwxr-xr-x
tabs
18.3
KB
-rwxr-xr-x
tac
38.41
KB
-rwxr-xr-x
tail
62.53
KB
-rwxr-xr-x
tapestat
26.44
KB
-rwxr-xr-x
tar
421.92
KB
-rwxr-xr-x
taskset
30.38
KB
-rwxr-xr-x
tbl
134.48
KB
-rwxr-xr-x
tclsh
14.15
KB
-rwxr-xr-x
tclsh8.6
14.15
KB
-rwxr-xr-x
tcpdump
1.21
MB
-rwxr-xr-x
tee
38.51
KB
-rwxr-xr-x
telnet
177.85
KB
-rwxr-xr-x
tempfile
14.3
KB
-rwxr-xr-x
test
46.44
KB
-rwxr-xr-x
tic
90.41
KB
-rwxr-xr-x
time
26.52
KB
-rwxr-xr-x
timedatectl
46.45
KB
-rwxr-xr-x
timeout
38.95
KB
-rwxr-xr-x
tkconch3
227
B
-rwxr-xr-x
tload
22.39
KB
-rwxr-xr-x
tmux
1.05
MB
-rwxr-xr-x
tnftp
182.9
KB
-rwxr-xr-x
toe
22.3
KB
-rwxr-xr-x
top
131.7
KB
-rwxr-xr-x
touch
94.51
KB
-rwxr-xr-x
tput
26.34
KB
-rwxr-xr-x
tr
46.51
KB
-rwxr-xr-x
trace-cmd
435.41
KB
-rwxr-xr-x
tracepath
18.15
KB
-rwxr-xr-x
trial3
219
B
-rwxr-xr-x
troff
726.62
KB
-rwxr-xr-x
true
26.3
KB
-rwxr-xr-x
truncate
38.51
KB
-rwxr-xr-x
tset
26.31
KB
-rwxr-xr-x
tsort
46.51
KB
-rwxr-xr-x
tty
34.51
KB
-rwxr-xr-x
turbostat
1.58
KB
-rwxr-xr-x
twist3
239
B
-rwxr-xr-x
twistd3
220
B
-rwxr-xr-x
tzselect
15.02
KB
-rwxr-xr-x
ua
1003
B
-rwxr-xr-x
ubuntu-advantage
1003
B
-rwxr-xr-x
ubuntu-bug
2.27
KB
-rwxr-xr-x
ubuntu-distro-info
26.89
KB
-rwxr-xr-x
ubuntu-security-status
22.25
KB
-rwxr-xr-x
ucf
40.68
KB
-rwxr-xr-x
ucfq
18.91
KB
-rwxr-xr-x
ucfr
10.85
KB
-rwxr-xr-x
uclampset
30.38
KB
-rwxr-xr-x
udevadm
1.37
MB
-rwxr-xr-x
udisksctl
62.38
KB
-rwxr-xr-x
ul
22.38
KB
-rwxr-xr-x
umount
38.38
KB
-rwsr-xr-x
uname
34.51
KB
-rwxr-xr-x
unattended-upgrade
97.21
KB
-rwxr-xr-x
unattended-upgrades
97.21
KB
-rwxr-xr-x
uncompress
2.29
KB
-rwxr-xr-x
unexpand
38.53
KB
-rwxr-xr-x
unicode_start
2.71
KB
-rwxr-xr-x
unicode_stop
528
B
-rwxr-xr-x
uniq
38.51
KB
-rwxr-xr-x
unlink
34.51
KB
-rwxr-xr-x
unlzma
86.92
KB
-rwxr-xr-x
unmkinitramfs
3.7
KB
-rwxr-xr-x
unshare
42.6
KB
-rwxr-xr-x
unsquashfs
147.9
KB
-rwxr-xr-x
unxz
86.92
KB
-rwxr-xr-x
unzip
174.42
KB
-rwxr-xr-x
unzipsfx
74.42
KB
-rwxr-xr-x
unzstd
998.79
KB
-rwxr-xr-x
update-alternatives
58.38
KB
-rwxr-xr-x
update-mime-database
74.33
KB
-rwxr-xr-x
uptime
14.38
KB
-rwxr-xr-x
usb-devices
4.83
KB
-rwxr-xr-x
usbhid-dump
30.38
KB
-rwxr-xr-x
usbip
1.58
KB
-rwxr-xr-x
usbipd
1.58
KB
-rwxr-xr-x
usbreset
14.3
KB
-rwxr-xr-x
users
34.51
KB
-rwxr-xr-x
utmpdump
22.38
KB
-rwxr-xr-x
uuidgen
18.38
KB
-rwxr-xr-x
uuidparse
22.38
KB
-rwxr-xr-x
varlinkctl
30.45
KB
-rwxr-xr-x
vcs-run
6.75
KB
-rwxr-xr-x
vdir
138.98
KB
-rwxr-xr-x
vi
3.94
MB
-rwxr-xr-x
view
3.94
MB
-rwxr-xr-x
vigpg
2.58
KB
-rwxr-xr-x
vim
3.94
MB
-rwxr-xr-x
vim.basic
3.94
MB
-rwxr-xr-x
vim.tiny
1.66
MB
-rwxr-xr-x
vimdiff
3.94
MB
-rwxr-xr-x
vimtutor
2.1
KB
-rwxr-xr-x
vm-support
9.83
KB
-rwxr-xr-x
vmhgfs-fuse
46.73
KB
-rwxr-xr-x
vmstat
38.78
KB
-rwxr-xr-x
vmtoolsd
74.56
KB
-rwxr-xr-x
vmware-alias-import
42.52
KB
-rwxr-xr-x
vmware-checkvm
14.38
KB
-rwxr-xr-x
vmware-hgfsclient
14.38
KB
-rwxr-xr-x
vmware-namespace-cmd
22.3
KB
-rwxr-xr-x
vmware-rpctool
18.3
KB
-rwxr-xr-x
vmware-toolbox-cmd
54.59
KB
-rwxr-xr-x
vmware-vgauth-cmd
18.3
KB
-rwxr-xr-x
vmware-vmblock-fuse
22.78
KB
-rwxr-xr-x
vmware-xferlogs
32.33
KB
-rwxr-xr-x
vnstat
149.36
KB
-rwxr-xr-x
vsftpdwho
54
B
-rwxr-xr-x
w
26.38
KB
-rwxr-xr-x
w3m
1.58
MB
-rwxr-xr-x
w3mman
1.37
KB
-rwxr-xr-x
wall
22.38
KB
-rwxr-xr-x
watch
30.84
KB
-rwxr-xr-x
watchgnupg
22.3
KB
-rwxr-xr-x
wc
54.52
KB
-rwxr-xr-x
wdctl
34.4
KB
-rwxr-xr-x
wget
459.02
KB
-rwxr-xr-x
whatis
47.28
KB
-rwxr-xr-x
whereis
30.84
KB
-rwxr-xr-x
which
1.05
KB
-rwxr-xr-x
which.debianutils
1.05
KB
-rwxr-xr-x
whiptail
30.16
KB
-rwxr-xr-x
who
58.52
KB
-rwxr-xr-x
whoami
34.51
KB
-rwxr-xr-x
whois
155.66
KB
-rwxr-xr-x
wifi-status
2.06
KB
-rwxr-xr-x
write
22.38
KB
-rwxr-xr-x
wrk
78.87
KB
-rwxr-xr-x
wsrep_sst_backup
2.39
KB
-rwxr-xr-x
wsrep_sst_common
66.86
KB
-rwxr-xr-x
wsrep_sst_mariabackup
49.23
KB
-rwxr-xr-x
wsrep_sst_mysqldump
8.11
KB
-rwxr-xr-x
wsrep_sst_rsync
29.72
KB
-rwxr-xr-x
wsrep_sst_rsync_wan
29.72
KB
-rwxr-xr-x
www-browser
1.58
MB
-rwxr-xr-x
x86_64
26.65
KB
-rwxr-xr-x
x86_energy_perf_policy
1.58
KB
-rwxr-xr-x
xargs
62.41
KB
-rwxr-xr-x
xauth
54.96
KB
-rwxr-xr-x
xdg-user-dir
234
B
-rwxr-xr-x
xdg-user-dirs-update
26.23
KB
-rwxr-xr-x
xsubpp
5.05
KB
-rwxr-xr-x
xxd
22.28
KB
-rwxr-xr-x
xz
86.92
KB
-rwxr-xr-x
xzcat
86.92
KB
-rwxr-xr-x
xzcmp
7.25
KB
-rwxr-xr-x
xzdiff
7.25
KB
-rwxr-xr-x
xzegrep
10.09
KB
-rwxr-xr-x
xzfgrep
10.09
KB
-rwxr-xr-x
xzgrep
10.09
KB
-rwxr-xr-x
xzless
1.77
KB
-rwxr-xr-x
xzmore
2.14
KB
-rwxr-xr-x
yes
34.38
KB
-rwxr-xr-x
ypdomainname
22.23
KB
-rwxr-xr-x
zcat
1.94
KB
-rwxr-xr-x
zcmp
1.64
KB
-rwxr-xr-x
zdiff
6.31
KB
-rwxr-xr-x
zdump
30.28
KB
-rwxr-xr-x
zegrep
29
B
-rwxr-xr-x
zfgrep
29
B
-rwxr-xr-x
zforce
2.03
KB
-rwxr-xr-x
zgrep
7.91
KB
-rwxr-xr-x
zip
206.98
KB
-rwxr-xr-x
zipcloak
70.4
KB
-rwxr-xr-x
zipdetails
68.55
KB
-rwxr-xr-x
zipgrep
2.89
KB
-rwxr-xr-x
zipinfo
174.42
KB
-rwxr-xr-x
zipnote
62.4
KB
-rwxr-xr-x
zipsplit
58.4
KB
-rwxr-xr-x
zless
2.15
KB
-rwxr-xr-x
zmore
1.8
KB
-rwxr-xr-x
znew
4.47
KB
-rwxr-xr-x
zstd
998.79
KB
-rwxr-xr-x
zstdcat
998.79
KB
-rwxr-xr-x
zstdgrep
3.78
KB
-rwxr-xr-x
zstdless
197
B
-rwxr-xr-x
zstdmt
998.79
KB
-rwxr-xr-x
Delete
Unzip
Zip
${this.title}
Close
Code Editor : wsrep_sst_mariabackup
#!/usr/bin/env bash set -ue # Copyright (C) 2017-2024 MariaDB # Copyright (C) 2013 Percona Inc # # This program is free software; you can redistribute it and/or modify # it under the terms of the GNU General Public License as published by # the Free Software Foundation; version 2 of the License. # # This program is distributed in the hope that it will be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # # You should have received a copy of the GNU General Public License # along with this program; see the file COPYING. If not, write to the # Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston # MA 02110-1335 USA. # This is a reference script for mariadb-backup-based state snapshot transfer. # Documentation: # https://mariadb.com/kb/en/mariabackup-overview/ # Make sure to read that before proceeding! . $(dirname "$0")/wsrep_sst_common BACKUP_BIN=$(commandex 'mariadb-backup') if [ -z "$BACKUP_BIN" ]; then wsrep_log_error 'mariadb-backup binary not found in path' exit 42 fi BACKUP_PID="" INFO_FILE='xtrabackup_galera_info' DONOR_INFO_FILE='donor_galera_info' IST_FILE='xtrabackup_ist' MAGIC_FILE="$DATA/$INFO_FILE" DONOR_MAGIC_FILE="$DATA/$DONOR_INFO_FILE" ealgo="" eformat="" ekey="" ekeyfile="" encrypt=0 ssyslog="" ssystag="" tcert="" tcap="" tpem="" tkey="" tmode="" sockopt="" progress="" ttime=0 totime=0 lsn="" ecmd="" rlimit="" # Initially stagemsg="$WSREP_SST_OPT_ROLE" cpat="" speciald=1 ib_home_dir="" ib_log_dir="" ib_undo_dir="" ar_log_dir="" sfmt="" strmcmd="" tfmt="" tcmd="" payload=0 pvformat="-F '%N => Rate:%r Avg:%a Elapsed:%t %e Bytes: %b %p'" pvopts="-f -i 10 -N $WSREP_SST_OPT_ROLE" uextra=0 disver="" STATDIR="" tmpopts="" itmpdir="" xtmpdir="" scomp="" sdecomp="" ssl_dhparams="" compress='none' compress_chunk="" compress_threads="" backup_threads="" encrypt_threads="" encrypt_chunk="" readonly SECRET_TAG='secret' readonly TOTAL_TAG='total' # Required for backup locks # For backup locks it is 1 sent by joiner sst_ver=1 INNOAPPLYLOG="$DATA/mariabackup.prepare.log" INNOMOVELOG="$DATA/mariabackup.move.log" INNOBACKUPLOG="$DATA/mariabackup.backup.log" timeit() { local stage="$1" shift local cmd="$@" local x1 x2 took extcode if [ $ttime -eq 1 ]; then x1=$(date +%s) fi wsrep_log_info "Evaluating $cmd" eval $cmd extcode=$? if [ $ttime -eq 1 ]; then x2=$(date +%s) took=$(( x2-x1 )) wsrep_log_info "NOTE: $stage took $took seconds" totime=$(( totime+took )) fi return $extcode } get_keys() { # $encrypt -eq 1 is for internal purposes only if [ $encrypt -ge 2 -o $encrypt -eq -1 ]; then return fi if [ $encrypt -eq 0 ]; then if [ -n "$ealgo" -o -n "$ekey" -o -n "$ekeyfile" ]; then wsrep_log_error "Options for encryption are specified," \ "but encryption itself is disabled. SST may fail." fi return fi if [ "$sfmt" = 'tar' ]; then wsrep_log_info "NOTE: key-based encryption (encrypt=1)" \ "cannot be enabled with tar format" encrypt=-1 return fi wsrep_log_info "Key based encryption enabled in my.cnf" if [ -z "$ealgo" ]; then wsrep_log_error "FATAL: Encryption algorithm empty from my.cnf, bailing out" exit 3 fi if [ -z "$ekey" -a ! -r "$ekeyfile" ]; then wsrep_log_error "FATAL: Either key must be specified" \ "or keyfile must be readable" exit 3 fi if [ "$eformat" = 'openssl' ]; then get_openssl if [ -z "$OPENSSL_BINARY" ]; then wsrep_log_error "If encryption using the openssl is enabled," \ "then you need to install openssl" exit 2 fi ecmd="'$OPENSSL_BINARY' enc -$ealgo" if "$OPENSSL_BINARY" enc -help 2>&1 | grep -qw -F -- '-pbkdf2'; then ecmd="$ecmd -pbkdf2" elif "$OPENSSL_BINARY" enc -help 2>&1 | grep -qw -F -- '-iter'; then ecmd="$ecmd -iter 1" elif "$OPENSSL_BINARY" enc -help 2>&1 | grep -qw -F -- '-md'; then ecmd="$ecmd -md sha256" fi if [ -z "$ekey" ]; then ecmd="$ecmd -kfile '$ekeyfile'" else ecmd="$ecmd -k '$ekey'" fi elif [ "$eformat" = 'xbcrypt' ]; then if [ -z "$(commandex xbcrypt)" ]; then wsrep_log_error "If encryption using the xbcrypt is enabled," \ "then you need to install xbcrypt" exit 2 fi wsrep_log_info "NOTE: xbcrypt-based encryption," \ "supported only from Xtrabackup 2.1.4" if [ -z "$ekey" ]; then ecmd="xbcrypt --encrypt-algo='$ealgo' --encrypt-key-file='$ekeyfile'" else ecmd="xbcrypt --encrypt-algo='$ealgo' --encrypt-key='$ekey'" fi if [ -n "$encrypt_threads" ]; then ecmd="$ecmd --encrypt-threads=$encrypt_threads" fi if [ -n "$encrypt_chunk" ]; then ecmd="$ecmd --encrypt-chunk-size=$encrypt_chunk" fi else wsrep_log_error "Unknown encryption format='$eformat'" exit 2 fi [ "$WSREP_SST_OPT_ROLE" = 'joiner' ] && ecmd="$ecmd -d" stagemsg="$stagemsg-XB-Encrypted" } get_socat_ver() { [ -n "${SOCAT_VERSION+x}" ] && return # Determine the socat version SOCAT_VERSION=$(socat -V 2>&1 | \ grep -m1 -owE '[0-9]+(\.[0-9]+)+' | \ head -n1 || :) if [ -z "$SOCAT_VERSION" ]; then wsrep_log_error "******** FATAL ERROR ******************" wsrep_log_error "* Cannot determine the socat version. *" wsrep_log_error "***************************************" exit 2 fi } get_transfer() { if [ "$tfmt" = 'nc' ]; then wsrep_log_info "Using netcat as streamer" wsrep_check_programs nc tcmd='nc' if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then if nc -h 2>&1 | grep -q -F 'ncat'; then wsrep_log_info "Using Ncat as streamer" tcmd="$tcmd -l" elif nc -h 2>&1 | grep -qw -F -- '-d'; then wsrep_log_info "Using Debian netcat as streamer" tcmd="$tcmd -dl" if [ $WSREP_SST_OPT_HOST_IPv6 -eq 1 ]; then # When host is not explicitly specified (when only the port # is specified) netcat can only bind to an IPv4 address if # the "-6" option is not explicitly specified: tcmd="$tcmd -6" fi else wsrep_log_info "Using traditional netcat as streamer" tcmd="$tcmd -l -p" fi tcmd="$tcmd $SST_PORT" else # Check to see if netcat supports the '-N' flag. # -N Shutdown the network socket after EOF on stdin # If it supports the '-N' flag, then we need to use the '-N' # flag, otherwise the transfer will stay open after the file # transfer and cause the command to timeout. # Older versions of netcat did not need this flag and will # return an error if the flag is used. if nc -h 2>&1 | grep -qw -F -- '-N'; then tcmd="$tcmd -N" wsrep_log_info "Using nc -N" fi # netcat doesn't understand [] around IPv6 address if nc -h 2>&1 | grep -q -F 'ncat'; then wsrep_log_info "Using Ncat as streamer" elif nc -h 2>&1 | grep -qw -F -- '-d'; then wsrep_log_info "Using Debian netcat as streamer" else wsrep_log_info "Using traditional netcat as streamer" tcmd="$tcmd -q0" fi tcmd="$tcmd $WSREP_SST_OPT_HOST_UNESCAPED $SST_PORT" fi else tfmt='socat' wsrep_log_info "Using socat as streamer" wsrep_check_programs socat if [ -n "$sockopt" ]; then sockopt=$(trim_string "$sockopt" ',') if [ -n "$sockopt" ]; then sockopt=",$sockopt" fi fi # Add an option for ipv6 if needed: if [ $WSREP_SST_OPT_HOST_IPv6 -eq 1 ]; then # If sockopt contains 'pf=ip6' somewhere in the middle, # this will not interfere with socat, but exclude the trivial # cases when sockopt contains 'pf=ip6' as prefix or suffix: if [ "$sockopt" = "${sockopt#,pf=ip6,}" -a \ "$sockopt" = "${sockopt%,pf=ip6}" ] then sockopt=",pf=ip6$sockopt" fi fi if [ $encrypt -lt 2 ]; then if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then tcmd="socat -u TCP-LISTEN:$SST_PORT,reuseaddr$sockopt stdio" else tcmd="socat -u stdio TCP:$REMOTEIP:$SST_PORT$sockopt" fi return fi if ! socat -V | grep -q -F 'WITH_OPENSSL 1'; then wsrep_log_error "******** FATAL ERROR ************************************************ " wsrep_log_error "* Encryption requested, but socat is not OpenSSL enabled (encrypt=$encrypt) *" wsrep_log_error "********************************************************************* " exit 2 fi local action='Decrypting' if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then tcmd="socat -u openssl-listen:$SST_PORT,reuseaddr" else local addr="$REMOTEIP:$SST_PORT" tcmd="socat -u stdio openssl-connect:$addr" action='Encrypting' get_socat_ver if ! check_for_version "$SOCAT_VERSION" '1.7.4.1'; then if check_for_version "$SOCAT_VERSION" '1.7.3.3'; then # Workaround for a bug known as 'Red Hat issue 1870279' # (connection reset by peer) in socat versions 1.7.3.3 # to 1.7.4.0: tcmd="socat stdio openssl-connect:$addr,linger=10" wsrep_log_info \ "Use workaround for socat $SOCAT_VERSION bug" fi fi if check_for_version "$SOCAT_VERSION" '1.7.4'; then tcmd="$tcmd,no-sni=1" fi fi if [ "${sockopt#*,dhparam=}" = "$sockopt" ]; then if [ -z "$ssl_dhparams" ]; then get_socat_ver if ! check_for_version "$SOCAT_VERSION" '1.7.3'; then # socat versions < 1.7.3 will have 512-bit dhparams (too small) # so create 2048-bit dhparams and send that as a parameter: check_for_dhparams fi fi if [ -n "$ssl_dhparams" ]; then tcmd="$tcmd,dhparam='$ssl_dhparams'" fi fi CN_option=",commonname=''" if [ $encrypt -eq 2 ]; then wsrep_log_info \ "Using openssl based encryption with socat: with crt and pem" if [ -z "$tpem" -o -z "$tcert$tcap" ]; then wsrep_log_error \ "Both PEM file and CRT file (or path) are required" exit 22 fi verify_ca_matches_cert "$tpem" "$tcert" "$tcap" tcmd="$tcmd,cert='$tpem'" if [ -n "$tcert" ]; then tcmd="$tcmd,cafile='$tcert'" fi if [ -n "$tcap" ]; then tcmd="$tcmd,capath='$tcap'" fi stagemsg="$stagemsg-OpenSSL-Encrypted-2" wsrep_log_info "$action with cert='$tpem', ca='$tcert', capath='$tcap'" elif [ $encrypt -eq 3 -o $encrypt -eq 4 ]; then wsrep_log_info \ "Using openssl based encryption with socat: with key and crt" if [ -z "$tpem" -o -z "$tkey" ]; then wsrep_log_error "Both the certificate file (or path) and" \ "the key file are required" exit 22 fi verify_cert_matches_key "$tpem" "$tkey" stagemsg="$stagemsg-OpenSSL-Encrypted-3" if [ -z "$tcert$tcap" ]; then if [ $encrypt -eq 4 ]; then wsrep_log_error \ "Peer certificate file (or path) required if encrypt=4" exit 22 fi # no verification CN_option="" tcmd="$tcmd,cert='$tpem',key='$tkey',verify=0" wsrep_log_info \ "$action with cert='$tpem', key='$tkey', verify=0" else # CA verification verify_ca_matches_cert "$tpem" "$tcert" "$tcap" if [ -n "$WSREP_SST_OPT_REMOTE_USER" ]; then CN_option=",commonname='$WSREP_SST_OPT_REMOTE_USER'" elif [ "$WSREP_SST_OPT_ROLE" = 'joiner' -o $encrypt -eq 4 ] then CN_option=",commonname=''" elif is_local_ip "$WSREP_SST_OPT_HOST_UNESCAPED"; then CN_option=',commonname=localhost' else CN_option=",commonname='$WSREP_SST_OPT_HOST_UNESCAPED'" fi tcmd="$tcmd,cert='$tpem',key='$tkey'" if [ -n "$tcert" ]; then tcmd="$tcmd,cafile='$tcert'" fi if [ -n "$tcap" ]; then tcmd="$tcmd,capath='$tcap'" fi wsrep_log_info "$action with cert='$tpem', key='$tkey'," \ "ca='$tcert', capath='$tcap'" fi else wsrep_log_info "Unknown encryption mode: encrypt=$encrypt" exit 22 fi tcmd="$tcmd$CN_option$sockopt" if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then tcmd="$tcmd stdio" fi fi } get_footprint() { cd "$DATA_DIR" local payload_data if [ "$OS" = 'Linux' ]; then payload_data=$(find $findopt . \ -regex '.*undo[0-9]+$\|.*\.ibd$\|.*\.MYI$\|.*\.MYD$\|.*ibdata1$' \ -type f -print0 | du --files0-from=- --bytes -c -s | \ awk 'END { print $1 }') else payload_data=$(find $findopt . \ -regex '.*undo[0-9]+$|.*\.ibd$|.*\.MYI$\.*\.MYD$|.*ibdata1$' \ -type f -print0 | xargs -0 stat -f '%z' | \ awk '{ sum += $1 } END { print sum }') fi local payload_undo=0 if [ -n "$ib_undo_dir" -a "$ib_undo_dir" != '.' -a \ "$ib_undo_dir" != "$DATA_DIR" -a -d "$ib_undo_dir" ] then cd "$ib_undo_dir" if [ "$OS" = 'Linux' ]; then payload_undo=$(find . -regex '.*undo[0-9]+$' -type f -print0 | \ du --files0-from=- --bytes -c -s | awk 'END { print $1 }') else payload_undo=$(find . -regex '.*undo[0-9]+$' -type f -print0 | \ xargs -0 stat -f '%z' | awk '{ sum += $1 } END { print sum }') fi fi cd "$OLD_PWD" wsrep_log_info \ "SST footprint estimate: data: $payload_data, undo: $payload_undo" payload=$(( payload_data+payload_undo )) if [ "$compress" != 'none' ]; then # QuickLZ has around 50% compression ratio # When compression/compaction used, the progress is only an approximate. payload=$(( payload*1/2 )) fi if [ $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # report to parent the total footprint of the SST echo "$TOTAL_TAG $payload" fi adjust_progress } adjust_progress() { pcmd="" rcmd="" [ "$progress" = 'none' ] && return rlimitopts="" if [ -n "$rlimit" -a "$WSREP_SST_OPT_ROLE" = 'donor' ]; then wsrep_log_info "Rate-limiting SST to $rlimit" rlimitopts=" -L $rlimit" fi if [ -n "$progress" ]; then # Backward compatibility: user-configured progress output pcmd="pv $pvopts$rlimitopts" if [ -z "${PV_FORMAT+x}" ]; then PV_FORMAT=0 pv --help | grep -qw -F -- '-F' && PV_FORMAT=1 fi if [ $PV_FORMAT -eq 1 ]; then pcmd="$pcmd $pvformat" fi if [ $payload -ne 0 ]; then pcmd="$pcmd -s $payload" fi if [ "$progress" != '1' ]; then if [ -e "$progress" ]; then pcmd="$pcmd 2>>'$progress'" else pcmd="$pcmd 2>'$progress'" fi fi elif [ $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # Default progress output parseable by parent pcmd="pv -f -i 1 -n -b$rlimitopts" # read progress data, add tag and post to stdout # for the parent rcmd="stdbuf -oL tr '\r' '\n' | xargs -n1 echo complete" elif [ -n "$rlimitopts" ]; then # Rate-limiting only, when rlimit is non-zero pcmd="pv -q$rlimitopts" fi } bkgroups='sst|xtrabackup|mariabackup' encgroups="--mysqld|$bkgroups" read_cnf() { sfmt=$(parse_cnf sst streamfmt 'mbstream') tfmt=$(parse_cnf sst transferfmt 'socat') encrypt=$(parse_cnf "$encgroups" 'encrypt' 0) tmode=$(parse_cnf "$encgroups" 'ssl-mode' 'DISABLED' | \ tr '[[:lower:]]' '[[:upper:]]') case "$tmode" in 'VERIFY_IDENTITY'|'VERIFY_CA'|'REQUIRED'|'DISABLED') ;; *) wsrep_log_error "Unrecognized ssl-mode option: '$tmode'" exit 22 # EINVAL ;; esac if [ $encrypt -eq 0 -o $encrypt -ge 2 ]; then if [ "$tmode" != 'DISABLED' -o $encrypt -ge 2 ]; then check_server_ssl_config fi if [ "$tmode" != 'DISABLED' ]; then if [ 0 -eq $encrypt -a -n "$tpem" -a -n "$tkey" ] then encrypt=3 # enable cert/key SSL encyption # avoid CA verification if not set explicitly: # nodes may happen to have different CA if self-generated, # zeroing up tcert and tcap does the trick: if [ "${tmode#VERIFY}" = "$tmode" ]; then tcert="" tcap="" fi fi fi elif [ $encrypt -eq 1 ]; then ealgo=$(parse_cnf "$encgroups" 'encrypt-algo') eformat=$(parse_cnf "$encgroups" 'encrypt-format' 'openssl') ekey=$(parse_cnf "$encgroups" 'encrypt-key') # The keyfile should be read only when the key # is not specified or empty: if [ -z "$ekey" ]; then ekeyfile=$(parse_cnf "$encgroups" 'encrypt-key-file') fi fi wsrep_log_info "SSL configuration: CA='$tcert', CAPATH='$tcap'," \ "CERT='$tpem', KEY='$tkey', MODE='$tmode'," \ "encrypt='$encrypt'" if [ $encrypt -ge 2 ]; then ssl_dhparams=$(parse_cnf "$encgroups" 'ssl-dhparams') fi sockopt=$(parse_cnf sst sockopt) progress=$(parse_cnf sst progress) ttime=$(parse_cnf sst time 0) cpat='.*\.pem$\|.*galera\.cache$\|.*sst_in_progress$\|.*\.sst$\|.*gvwstate\.dat$\|.*grastate\.dat$\|.*\.err$\|.*\.log$\|.*RPM_UPGRADE_MARKER$\|.*RPM_UPGRADE_HISTORY$' [ "$OS" = 'FreeBSD' ] && cpat=$(echo "$cpat" | sed 's/\\|/|/g') cpat=$(parse_cnf sst cpat "$cpat") scomp=$(parse_cnf sst compressor) sdecomp=$(parse_cnf sst decompressor) rlimit=$(parse_cnf sst rlimit) uextra=$(parse_cnf sst use-extra 0) speciald=$(parse_cnf sst 'sst-special-dirs' 1) iopts=$(parse_cnf "$bkgroups" 'inno-backup-opts') iapts=$(parse_cnf "$bkgroups" 'inno-apply-opts') impts=$(parse_cnf "$bkgroups" 'inno-move-opts') use_memory=$(parse_cnf "$bkgroups" 'use-memory') if [ -z "$use_memory" ]; then if [ -n "$INNODB_BUFFER_POOL_SIZE" ]; then use_memory="$INNODB_BUFFER_POOL_SIZE" else use_memory=$(parse_cnf '--mysqld' 'innodb-buffer-pool-size') fi fi stimeout=$(parse_cnf sst 'sst-initial-timeout' 300) ssyslog=$(parse_cnf sst 'sst-syslog' 0) ssystag=$(parse_cnf mysqld_safe 'syslog-tag' "${SST_SYSLOG_TAG:-}") ssystag="$ssystag-" sstlogarchive=$(parse_cnf sst 'sst-log-archive' 1) sstlogarchivedir="" if [ $sstlogarchive -ne 0 ]; then sstlogarchivedir=$(parse_cnf sst sst-log-archive-dir \ '/tmp/sst_log_archive') if [ -n "$sstlogarchivedir" ]; then sstlogarchivedir=$(trim_dir "$sstlogarchivedir") fi fi if [ $speciald -eq 0 ]; then wsrep_log_error \ "sst-special-dirs equal to 0 is not supported, falling back to 1" speciald=1 fi if [ $ssyslog -ne -1 ]; then ssyslog=$(in_config 'mysqld_safe' 'syslog') fi if [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then compress=$(parse_cnf "$encgroups" 'compress' 'none') if [ "$compress" != 'none' ]; then compress_chunk=$(parse_cnf "$encgroups" 'compress-chunk-size') compress_threads=$(parse_cnf "$encgroups" 'compress-threads') fi fi backup_threads=$(parse_cnf "$encgroups" 'backup-threads') if [ "$eformat" = 'xbcrypt' ]; then encrypt_threads=$(parse_cnf "$encgroups" 'encrypt-threads') encrypt_chunk=$(parse_cnf "$encgroups" 'encrypt-chunk-size') fi } get_stream() { if [ "$sfmt" = 'mbstream' -o "$sfmt" = 'xbstream' ]; then sfmt='mbstream' local STREAM_BIN=$(commandex "$sfmt") if [ -z "$STREAM_BIN" ]; then wsrep_log_error "Streaming with $sfmt, but $sfmt not found in path" exit 42 fi if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then strmcmd="'$STREAM_BIN' -x" else strmcmd="'$STREAM_BIN' -c '$INFO_FILE' '$DONOR_INFO_FILE'" fi else sfmt='tar' if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then strmcmd='tar xfi -' else strmcmd="tar cf - '$INFO_FILE' '$DONOR_INFO_FILE'" fi fi wsrep_log_info "Streaming with $sfmt" } cleanup_at_exit() { # Since this is invoked just after exit NNN local estatus=$? if [ $estatus -ne 0 ]; then wsrep_log_error "Cleanup after exit with status: $estatus" elif [ -z "${coords:-}" -a "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then estatus=32 wsrep_log_error "Failed to get current position" fi [ "$(pwd)" != "$OLD_PWD" ] && cd "$OLD_PWD" if [ "$WSREP_SST_OPT_ROLE" = 'donor' -o $estatus -ne 0 ]; then if [ $estatus -ne 0 ]; then wsrep_log_error "Removing $MAGIC_FILE file due to signal" fi [ -f "$MAGIC_FILE" ] && rm -f "$MAGIC_FILE" || : [ -f "$DONOR_MAGIC_FILE" ] && rm -f "$DONOR_MAGIC_FILE" || : [ -f "$DATA/$IST_FILE" ] && rm -f "$DATA/$IST_FILE" || : fi if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then if [ -n "$BACKUP_PID" ]; then if ps -p $BACKUP_PID >/dev/null 2>&1; then wsrep_log_error \ "SST streaming process is still running. Killing..." cleanup_pid $BACKUP_PID fi fi wsrep_log_info "Removing the sst_in_progress file" wsrep_cleanup_progress_file fi if [ -n "$progress" -a -p "$progress" ]; then wsrep_log_info "Cleaning up fifo file: $progress" rm -f "$progress" || : fi wsrep_log_info "Cleaning up temporary directories" if [ "$WSREP_SST_OPT_ROLE" = 'joiner' ]; then [ -n "$STATDIR" -a -d "$STATDIR" ] && rm -rf "$STATDIR" || : else [ -n "$xtmpdir" -a -d "$xtmpdir" ] && rm -rf "$xtmpdir" || : [ -n "$itmpdir" -a -d "$itmpdir" ] && rm -rf "$itmpdir" || : fi # Final cleanup local pgid=$(ps -o 'pgid=' $$ 2>/dev/null | grep -o -E '[0-9]+' || :) # This means no setsid done in mysqld. # We don't want to kill mysqld here otherwise. if [ -n "$pgid" ]; then if [ $$ -eq $pgid ]; then # This means a signal was delivered to the process. # So, more cleanup. if [ $estatus -ge 128 ]; then kill -KILL -- -$$ || : fi fi fi if [ -n "$SST_PID" ]; then [ -f "$SST_PID" ] && rm -f "$SST_PID" || : fi exit $estatus } setup_ports() { SST_PORT="$WSREP_SST_OPT_PORT" if [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then REMOTEIP="$WSREP_SST_OPT_HOST" lsn="$WSREP_SST_OPT_LSN" sst_ver="$WSREP_SST_OPT_SST_VER" fi } # # Waits ~30 seconds for socat or nc to open the port and # then reports ready, regardless of timeout. # wait_for_listen() { for i in {1..150}; do if check_port "" "$SST_PORT" 'socat|nc|netcat'; then break fi sleep 0.2 done echo "ready $ADDR:$SST_PORT/$MODULE/$lsn/$sst_ver" } check_extra() { local use_socket=1 if [ $uextra -eq 1 ]; then local thread_handling=$(parse_cnf '--mysqld' 'thread-handling') if [ "$thread_handling" = 'pool-of-threads' ]; then local eport=$(parse_cnf '--mysqld' 'extra-port') if [ -n "$eport" ]; then # mariadb-backup works only locally. # Hence, setting host to 127.0.0.1 unconditionally: wsrep_log_info "SST through extra_port $eport" INNOEXTRA="$INNOEXTRA --host=127.0.0.1 --port=$eport" use_socket=0 else wsrep_log_error "Extra port $eport null, failing" exit 1 fi else wsrep_log_info "Thread pool not set, ignore the option use_extra" fi fi if [ $use_socket -eq 1 -a -n "$WSREP_SST_OPT_SOCKET" ]; then INNOEXTRA="$INNOEXTRA --socket='$WSREP_SST_OPT_SOCKET'" fi } recv_joiner() { local dir="$1" local msg="$2" local tmt=$3 local checkf=$4 local wait=$5 if [ ! -d "$dir" ]; then # This indicates that IST is in progress return fi local ltcmd="$tcmd" if [ $tmt -gt 0 ]; then if [ -n "$(commandex timeout)" ]; then local koption=0 if [ "$OS" = 'FreeBSD' -o "$OS" = 'NetBSD' -o "$OS" = 'OpenBSD' -o \ "$OS" = 'DragonFly' ]; then if timeout 2>&1 | grep -qw -F -- '-k'; then koption=1 fi else if timeout --help | grep -qw -F -- '-k'; then koption=1 fi fi if [ $koption -ne 0 ]; then ltcmd="timeout -k $(( tmt+10 )) $tmt $tcmd" else ltcmd="timeout -s 9 $tmt $tcmd" fi fi fi if [ $wait -ne 0 ]; then wait_for_listen & fi cd "$dir" set +e timeit "$msg" "$ltcmd | $strmcmd; RC=( "\${PIPESTATUS[@]}" )" set -e cd "$OLD_PWD" if [ ${RC[0]} -eq 124 ]; then wsrep_log_error "Possible timeout in receiving first data from" \ "donor in gtid stage: exit codes: ${RC[@]}" exit 32 fi for ecode in "${RC[@]}"; do if [ $ecode -ne 0 ]; then wsrep_log_error "Error while getting data from donor node:" \ "exit codes: ${RC[@]}" exit 32 fi done if [ $checkf -eq 1 ]; then if [ ! -r "$MAGIC_FILE" ]; then # this message should cause joiner to abort: wsrep_log_error "receiving process ended without creating" \ "magic file ($MAGIC_FILE)" wsrep_log_info "Contents of datadir:" wsrep_log_info "$(ls -l "$dir"/*)" exit 32 fi if [ -n "$MY_SECRET" ]; then # Check donor supplied secret: SECRET=$(grep -m1 -E "^$SECRET_TAG[[:space:]]" "$MAGIC_FILE" || :) SECRET=$(trim_string "${SECRET#$SECRET_TAG}") if [ "$SECRET" != "$MY_SECRET" ]; then wsrep_log_error "Donor does not know my secret!" wsrep_log_info "Donor: '$SECRET', my: '$MY_SECRET'" exit 32 fi fi if [ $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # check total SST footprint payload=$(grep -m1 -E "^$TOTAL_TAG[[:space:]]" "$MAGIC_FILE" || :) if [ -n "$payload" ]; then payload=$(trim_string "${payload#$TOTAL_TAG}") if [ $payload -ge 0 ]; then # report to parent echo "$TOTAL_TAG $payload" fi fi fi fi } send_donor() { local dir="$1" local msg="$2" cd "$dir" set +e timeit "$msg" "$strmcmd | $tcmd; RC=( "\${PIPESTATUS[@]}" )" set -e cd "$OLD_PWD" for ecode in "${RC[@]}"; do if [ $ecode -ne 0 ]; then wsrep_log_error "Error while sending data to joiner node:" \ "exit codes: ${RC[@]}" exit 32 fi done } monitor_process() { local sst_stream_pid=$1 while :; do if ! ps -p $WSREP_SST_OPT_PARENT >/dev/null 2>&1; then wsrep_log_error \ "Parent mysqld process (PID: $WSREP_SST_OPT_PARENT)" \ "terminated unexpectedly." kill -- -$WSREP_SST_OPT_PARENT exit 32 fi if ! ps -p $sst_stream_pid >/dev/null 2>&1; then break fi sleep 0.1 done } read_cnf setup_ports if [ "$progress" = 'none' ]; then wsrep_log_info "All progress/rate-limiting disabled by configuration" elif [ -z "$(commandex pv)" ]; then wsrep_log_info "Progress reporting tool pv not found in path: $PATH" wsrep_log_info "Disabling all progress/rate-limiting" progress='none' fi if "$BACKUP_BIN" --help 2>/dev/null | grep -qw -F -- '--version-check'; then disver=' --no-version-check' fi get_stream get_transfer findopt='-L' [ "$OS" = 'FreeBSD' ] && findopt="$findopt -E" wait_previous_sst [ -f "$MAGIC_FILE" ] && rm -f "$MAGIC_FILE" [ -f "$DONOR_MAGIC_FILE" ] && rm -f "$DONOR_MAGIC_FILE" [ -f "$DATA/$IST_FILE" ] && rm -f "$DATA/$IST_FILE" if [ $ssyslog -eq 1 ]; then if [ -n "$(commandex logger)" ]; then wsrep_log_info "Logging all stderr of SST/mariadb-backup to syslog" exec 2> >(logger -p daemon.err -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE) wsrep_log_error() { logger -p daemon.err -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE -- "$@" } wsrep_log_warning() { logger -p daemon.warning -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE -- "$@" } wsrep_log_info() { logger -p daemon.info -t ${ssystag}wsrep-sst-$WSREP_SST_OPT_ROLE -- "$@" } else wsrep_log_error "logger not in path: $PATH. Ignoring" fi INNOAPPLY="2>&1 | logger -p daemon.err -t ${ssystag}innobackupex-apply" INNOMOVE="2>&1 | logger -p daemon.err -t ${ssystag}innobackupex-move" INNOBACKUP="2> >(logger -p daemon.err -t ${ssystag}innobackupex-backup)" else if [ $sstlogarchive -eq 1 ] then ARCHIVETIMESTAMP=$(date '+%Y.%m.%d-%H.%M.%S.%N') if [ -n "$sstlogarchivedir" ]; then if [ ! -d "$sstlogarchivedir" ]; then if ! mkdir -p "$sstlogarchivedir"; then sstlogarchivedir="" wsrep_log_warning \ "Unable to create '$sstlogarchivedir' directory" fi elif [ ! -w "$sstlogarchivedir" ]; then sstlogarchivedir="" wsrep_log_warning \ "The '$sstlogarchivedir' directory is not writtable" fi fi if [ -e "$INNOAPPLYLOG" ]; then if [ -n "$sstlogarchivedir" ]; then newfile=$(basename "$INNOAPPLYLOG") newfile="$sstlogarchivedir/$newfile.$ARCHIVETIMESTAMP" else newfile="$INNOAPPLYLOG.$ARCHIVETIMESTAMP" fi wsrep_log_info "Moving '$INNOAPPLYLOG' to '$newfile'" mv "$INNOAPPLYLOG" "$newfile" && gzip "$newfile" || \ wsrep_log_warning "Failed to archive log file ('$newfile')" fi if [ -e "$INNOMOVELOG" ]; then if [ -n "$sstlogarchivedir" ]; then newfile=$(basename "$INNOMOVELOG") newfile="$sstlogarchivedir/$newfile.$ARCHIVETIMESTAMP" else newfile="$INNOMOVELOG.$ARCHIVETIMESTAMP" fi wsrep_log_info "Moving '$INNOMOVELOG' to '$newfile'" mv "$INNOMOVELOG" "$newfile" && gzip "$newfile" || \ wsrep_log_warning "Failed to archive log file ('$newfile')" fi if [ -e "$INNOBACKUPLOG" ]; then if [ -n "$sstlogarchivedir" ]; then newfile=$(basename "$INNOBACKUPLOG") newfile="$sstlogarchivedir/$newfile.$ARCHIVETIMESTAMP" else newfile="$INNOBACKUPLOG.$ARCHIVETIMESTAMP" fi wsrep_log_info "Moving '$INNOBACKUPLOG' to '$newfile'" mv "$INNOBACKUPLOG" "$newfile" && gzip "$newfile" || \ wsrep_log_warning "Failed to archive log file ('$newfile')" fi fi INNOAPPLY="> '$INNOAPPLYLOG' 2>&1" INNOMOVE="> '$INNOMOVELOG' 2>&1" INNOBACKUP="2> '$INNOBACKUPLOG'" fi setup_commands() { local mysqld_args="" if [ -n "$WSREP_SST_OPT_MYSQLD" ]; then mysqld_args=" --mysqld-args $WSREP_SST_OPT_MYSQLD" fi local recovery="" if [ -n "$INNODB_FORCE_RECOVERY" ]; then recovery=" --innodb-force-recovery=$INNODB_FORCE_RECOVERY" fi if [ -n "$use_memory" ]; then INNOEXTRA="$INNOEXTRA --use-memory=$use_memory" fi INNOAPPLY="$BACKUP_BIN --prepare$disver$recovery${iapts:+ }$iapts$INNOEXTRA --target-dir='$DATA' --datadir='$DATA'$mysqld_args $INNOAPPLY" INNOMOVE="$BACKUP_BIN$WSREP_SST_OPT_CONF --move-back$disver${impts:+ }$impts$INNOEXTRA --galera-info --force-non-empty-directories --target-dir='$DATA' --datadir='${TDATA:-$DATA}' $INNOMOVE" INNOBACKUP="$BACKUP_BIN$WSREP_SST_OPT_CONF --backup$disver${iopts:+ }$iopts$tmpopts$INNOEXTRA --galera-info --stream=$sfmt --target-dir='$itmpdir' --datadir='$DATA'$mysqld_args $INNOBACKUP" } send_magic() { # Store donor's wsrep GTID (state ID) and wsrep_gtid_domain_id # (separated by a space). echo "$WSREP_SST_OPT_GTID $WSREP_SST_OPT_GTID_DOMAIN_ID" > "$MAGIC_FILE" echo "$WSREP_SST_OPT_GTID $WSREP_SST_OPT_GTID_DOMAIN_ID" > "$DONOR_MAGIC_FILE" if [ -n "$WSREP_SST_OPT_REMOTE_PSWD" ]; then # Let joiner know that we know its secret echo "$SECRET_TAG $WSREP_SST_OPT_REMOTE_PSWD" >> "$MAGIC_FILE" fi if [ $WSREP_SST_OPT_BYPASS -eq 0 -a $WSREP_SST_OPT_PROGRESS -eq 1 ]; then # Tell joiner what to expect: echo "$TOTAL_TAG $payload" >> "$MAGIC_FILE" fi } if [ "$WSREP_SST_OPT_ROLE" = 'donor' ]; then trap cleanup_at_exit EXIT if [ $WSREP_SST_OPT_BYPASS -eq 0 ] then if [ -z "$sst_ver" ]; then wsrep_log_error "Upgrade joiner to 5.6.21 or higher for backup locks support" wsrep_log_error "The joiner is not supported for this version of donor" exit 93 fi tmpdir=$(parse_cnf "$encgroups" 'tmpdir') if [ -z "$tmpdir" ]; then xtmpdir="$(mktemp -d)" itmpdir="$(mktemp -d)" elif [ "$OS" = 'Linux' ]; then xtmpdir=$(mktemp -d "--tmpdir=$tmpdir") itmpdir=$(mktemp -d "--tmpdir=$tmpdir") else xtmpdir=$(TMPDIR="$tmpdir"; mktemp -d) itmpdir=$(TMPDIR="$tmpdir"; mktemp -d) fi wsrep_log_info "Using '$xtmpdir' as mariadb-backup temporary directory" tmpopts=" --tmpdir='$xtmpdir'" wsrep_log_info "Using '$itmpdir' as mariadb-backup working directory" if [ -n "$WSREP_SST_OPT_USER" ]; then INNOEXTRA="$INNOEXTRA --user='$WSREP_SST_OPT_USER'" fi if [ -n "$WSREP_SST_OPT_PSWD" ]; then export MYSQL_PWD="$WSREP_SST_OPT_PSWD" elif [ -n "$WSREP_SST_OPT_USER" ]; then # Empty password, used for testing, debugging etc. unset MYSQL_PWD fi check_extra if [ -n "$progress" -o $WSREP_SST_OPT_PROGRESS -eq 1 ]; then wsrep_log_info "Estimating total transfer size" get_footprint wsrep_log_info "To transfer: $payload" else adjust_progress fi wsrep_log_info "Streaming GTID file before SST" send_magic ttcmd="$tcmd" if [ -n "$scomp" ]; then tcmd="$scomp | $tcmd" fi get_keys if [ $encrypt -eq 1 ]; then tcmd="$ecmd | $tcmd" fi send_donor "$DATA" "$stagemsg-gtid" # Restore the transport commmand to its original state tcmd="$ttcmd" if [ -n "$pcmd" ]; then if [ -n "$rcmd" ]; then # redirect pv stderr to rcmd for tagging and output to parent tcmd="{ $pcmd 2>&3 | $tcmd; } 3>&1 | $rcmd" else # use user-configured pv output tcmd="$pcmd | $tcmd" fi fi wsrep_log_info "Sleeping before data transfer for SST" sleep 10 wsrep_log_info "Streaming the backup to joiner at $REMOTEIP:$SST_PORT" # Add compression to the head of the stream (if specified) if [ -n "$scomp" ]; then tcmd="$scomp | $tcmd" fi # Add encryption to the head of the stream (if specified) if [ $encrypt -eq 1 ]; then tcmd="$ecmd | $tcmd" fi iopts="--databases-exclude='lost+found'${iopts:+ }$iopts" # if compression is enabled for backup files, then add the # appropriate options to the mariadb-backup command line: if [ "$compress" != 'none' ]; then iopts="--compress${compress:+=$compress}${iopts:+ }$iopts" if [ -n "$compress_threads" ]; then iopts="--compress-threads=$compress_threads${iopts:+ }$iopts" fi if [ -n "$compress_chunk" ]; then iopts="--compress-chunk-size=$compress_chunk${iopts:+ }$iopts" fi fi if [ -n "$backup_threads" ]; then iopts="--parallel=$backup_threads${iopts:+ }$iopts" fi setup_commands set +e timeit "$stagemsg-SST" "$INNOBACKUP | $tcmd; RC=( "\${PIPESTATUS[@]}" )" set -e if [ ${RC[0]} -ne 0 ]; then wsrep_log_error "mariadb-backup finished with error: ${RC[0]}." \ "Check syslog or '$INNOBACKUPLOG' for details" exit 22 elif [ ${RC[$(( ${#RC[@]}-1 ))]} -eq 1 ]; then wsrep_log_error "$tcmd finished with error: ${RC[1]}" exit 22 fi else # BYPASS FOR IST wsrep_log_info "Bypassing the SST for IST" echo 'continue' # now server can resume updating data send_magic echo '1' > "$DATA/$IST_FILE" if [ -n "$scomp" ]; then tcmd="$scomp | $tcmd" fi get_keys if [ $encrypt -eq 1 ]; then tcmd="$ecmd | $tcmd" fi strmcmd="$strmcmd '$IST_FILE'" send_donor "$DATA" "$stagemsg-IST" fi echo "done $WSREP_SST_OPT_GTID" wsrep_log_info "Total time on donor: $totime seconds" else # joiner create_dirs 1 [ -e "$SST_PROGRESS_FILE" ] && \ wsrep_log_info "Stale sst_in_progress file: $SST_PROGRESS_FILE" [ -n "$SST_PROGRESS_FILE" ] && touch "$SST_PROGRESS_FILE" if [ -n "$backup_threads" ]; then impts="--parallel=$backup_threads${impts:+ }$impts" fi stagemsg='Joiner-Recv' MODULE="${WSREP_SST_OPT_MODULE:-xtrabackup_sst}" ADDR="$WSREP_SST_OPT_HOST" if [ "${tmode#VERIFY}" != "$tmode" ]; then # backward-incompatible behavior: CN="" if [ -n "$tpem" ]; then CN=$(openssl_getCN "$tpem") fi MY_SECRET="$(wsrep_gen_secret)" # Add authentication data to address ADDR="$CN:$MY_SECRET@$ADDR" else MY_SECRET="" # for check down in recv_joiner() fi get_keys if [ $encrypt -eq 1 ]; then strmcmd="$ecmd | $strmcmd" fi if [ -n "$sdecomp" ]; then strmcmd="$sdecomp | $strmcmd" fi check_sockets_utils trap cleanup_at_exit EXIT STATDIR="$(mktemp -d)" MAGIC_FILE="$STATDIR/$INFO_FILE" DONOR_MAGIC_FILE="$STATDIR/$DONOR_INFO_FILE" recv_joiner "$STATDIR" "$stagemsg-gtid" $stimeout 1 1 if ! ps -p "$WSREP_SST_OPT_PARENT" >/dev/null 2>&1; then wsrep_log_error "Parent mysqld process (PID: $WSREP_SST_OPT_PARENT)" \ "terminated unexpectedly." exit 32 fi if [ ! -r "$STATDIR/$IST_FILE" ]; then adjust_progress if [ -n "$pcmd" ]; then if [ -n "$rcmd" ]; then # redirect pv stderr to rcmd for tagging and output to parent strmcmd="{ $pcmd 2>&3 | $strmcmd; } 3>&1 | $rcmd" else # use user-configured pv output strmcmd="$pcmd | $strmcmd" fi fi if [ -d "$DATA/.sst" ]; then wsrep_log_info \ "WARNING: Stale temporary SST directory:" \ "'$DATA/.sst' from previous state transfer, removing..." rm -rf "$DATA/.sst" fi mkdir -p "$DATA/.sst" (recv_joiner "$DATA/.sst" "$stagemsg-SST" 0 0 0) & BACKUP_PID=$! wsrep_log_info "Proceeding with SST" get_binlog if [ -n "$WSREP_SST_OPT_BINLOG" ]; then binlog_dir=$(dirname "$WSREP_SST_OPT_BINLOG") binlog_base=$(basename "$WSREP_SST_OPT_BINLOG") binlog_index="$WSREP_SST_OPT_BINLOG_INDEX" cd "$DATA" wsrep_log_info "Cleaning the old binary logs" # If there is a file with binlogs state, delete it: [ -f "$binlog_base.state" ] && rm "$binlog_base.state" >&2 # Clean up the old binlog files and index: if [ -f "$binlog_index" ]; then while read bin_file || [ -n "$bin_file" ]; do rm -f "$bin_file" >&2 || : done < "$binlog_index" rm "$binlog_index" >&2 fi if [ -n "$binlog_dir" -a "$binlog_dir" != '.' -a \ -d "$binlog_dir" ] then cd "$binlog_dir" if [ "$(pwd)" != "$DATA_DIR" ]; then wsrep_log_info \ "Cleaning the binlog directory '$binlog_dir' as well" fi fi rm -f "$binlog_base".[0-9]* >&2 || : cd "$OLD_PWD" fi wsrep_log_info \ "Cleaning the existing datadir and innodb-data/log directories" find $findopt ${ib_home_dir:+"$ib_home_dir"} \ ${ib_undo_dir:+"$ib_undo_dir"} \ ${ib_log_dir:+"$ib_log_dir"} \ ${ar_log_dir:+"$ar_log_dir"} \ "$DATA" -mindepth 1 -prune -regex "$cpat" \ -o -exec rm -rf {} >&2 \+ # Deleting files from previous SST and legacy files from old versions: [ -f "$DATA/xtrabackup_binary" ] && rm -f "$DATA/xtrabackup_binary" [ -f "$DATA/xtrabackup_pid" ] && rm -f "$DATA/xtrabackup_pid" [ -f "$DATA/xtrabackup_checkpoints" ] && rm -f "$DATA/xtrabackup_checkpoints" [ -f "$DATA/xtrabackup_info" ] && rm -f "$DATA/xtrabackup_info" [ -f "$DATA/xtrabackup_slave_info" ] && rm -f "$DATA/xtrabackup_slave_info" [ -f "$DATA/xtrabackup_binlog_info" ] && rm -f "$DATA/xtrabackup_binlog_info" [ -f "$DATA/xtrabackup_binlog_pos_innodb" ] && rm -f "$DATA/xtrabackup_binlog_pos_innodb" TDATA="$DATA" DATA="$DATA/.sst" MAGIC_FILE="$DATA/$INFO_FILE" wsrep_log_info "Waiting for SST streaming to complete!" monitor_process $BACKUP_PID BACKUP_PID="" if [ ! -s "$DATA/xtrabackup_checkpoints" ]; then wsrep_log_error "xtrabackup_checkpoints missing," \ "failed mariadb-backup/SST on donor" exit 2 fi # Compact backups are not supported by mariadb-backup if grep -qw -F 'compact = 1' "$DATA/xtrabackup_checkpoints"; then wsrep_log_info "Index compaction detected" wsrep_log_error "Compact backups are not supported by mariadb-backup" exit 2 fi qpfiles=$(find $findopt "$DATA" -maxdepth 1 -type f -name '*.qp' -print -quit) if [ -n "$qpfiles" ]; then wsrep_log_info "Compressed qpress files found" if [ -z "$(commandex qpress)" ]; then wsrep_log_error "qpress utility not found in the path" exit 22 fi get_proc dcmd="xargs -n 2 qpress -dT$nproc" if [ -n "$progress" -a "$progress" != 'none' ] && \ pv --help | grep -qw -F -- '--line-mode' then count=$(find $findopt "$DATA" -maxdepth 1 -type f -name '*.qp' | wc -l) count=$(( count*2 )) pvopts='-f -l -N Decompression' pvformat="-F '%N => Rate:%r Elapsed:%t %e Progress: [%b/$count]'" payload=$count adjust_progress dcmd="$pcmd | $dcmd" fi # Decompress the qpress files wsrep_log_info "Decompression with $nproc threads" timeit 'Joiner-Decompression' \ "find $findopt '$DATA' -type f -name '*.qp' -printf '%p\n%h\n' | \ $dcmd" extcode=$? if [ $extcode -eq 0 ]; then wsrep_log_info "Removing qpress files after decompression" find $findopt "$DATA" -type f -name '*.qp' -delete if [ $? -ne 0 ]; then wsrep_log_error \ "Something went wrong with deletion of qpress files." \ "Investigate" fi else wsrep_log_error "Decompression failed. Exit code: $extcode" exit 22 fi fi wsrep_log_info "Preparing the backup at $DATA" setup_commands timeit 'mariadb-backup prepare stage' "$INNOAPPLY" if [ $? -ne 0 ]; then wsrep_log_error "mariadb-backup apply finished with errors." \ "Check syslog or '$INNOAPPLYLOG' for details." exit 22 fi if [ -n "$WSREP_SST_OPT_BINLOG" ]; then cd "$DATA" binlogs="" if [ -f 'xtrabackup_binlog_info' ]; then NL=$'\n' while read bin_string || [ -n "$bin_string" ]; do bin_file=$(echo "$bin_string" | cut -f1) if [ -f "$bin_file" ]; then binlogs="$binlogs${binlogs:+$NL}$bin_file" fi done < 'xtrabackup_binlog_info' else binlogs=$(ls -d -1 "$binlog_base".[0-9]* 2>/dev/null || :) fi cd "$DATA_DIR" if [ -n "$binlog_dir" -a "$binlog_dir" != '.' -a \ "$binlog_dir" != "$DATA_DIR" ] then [ ! -d "$binlog_dir" ] && mkdir -p "$binlog_dir" fi index_dir=$(dirname "$binlog_index"); if [ -n "$index_dir" -a "$index_dir" != '.' -a \ "$index_dir" != "$DATA_DIR" ] then [ ! -d "$index_dir" ] && mkdir -p "$index_dir" fi if [ -n "$binlogs" ]; then wsrep_log_info "Moving binary logs to $binlog_dir" echo "$binlogs" | \ while read bin_file || [ -n "$bin_file" ]; do mv "$DATA/$bin_file" "$binlog_dir" echo "$binlog_dir${binlog_dir:+/}$bin_file" >> "$binlog_index" done fi cd "$OLD_PWD" fi MAGIC_FILE="$TDATA/$INFO_FILE" DONOR_MAGIC_FILE="$TDATA/$DONOR_INFO_FILE" wsrep_log_info "Moving the backup to $TDATA" timeit 'mariadb-backup move stage' "$INNOMOVE" if [ $? -eq 0 ]; then wsrep_log_info "Move successful, removing $DATA" rm -rf "$DATA" DATA="$TDATA" else wsrep_log_error "Move failed, keeping '$DATA' for further diagnosis" wsrep_log_error "Check syslog or '$INNOMOVELOG' for details" exit 22 fi else wsrep_log_info "'$IST_FILE' received from donor: Running IST" if [ $WSREP_SST_OPT_BYPASS -eq 0 ]; then readonly WSREP_SST_OPT_BYPASS=1 readonly WSREP_TRANSFER_TYPE='IST' fi fi if [ ! -r "$MAGIC_FILE" ]; then wsrep_log_error "Internal error: SST magic file '$MAGIC_FILE'" \ "not found or not readable" exit 2 fi simulate_long_sst # use donor magic file, if present # if IST was used, donor magic file was not created # Remove special tags from the magic file, and from the output: if [ -r "$DONOR_MAGIC_FILE" ]; then coords=$(head -n1 "$DONOR_MAGIC_FILE") wsrep_log_info "Galera co-ords from donor: $coords" else coords=$(head -n1 "$MAGIC_FILE") wsrep_log_info "Galera co-ords from recovery: $coords" fi echo "$coords" # Output : UUID:seqno wsrep_gtid_domain_id wsrep_log_info "Total time on joiner: $totime seconds" fi wsrep_log_info "$WSREP_METHOD $WSREP_TRANSFER_TYPE completed on $WSREP_SST_OPT_ROLE" exit 0
Close